<?php // $Id: index.php,v 1.2 2004/05/10 18:03:53 dyksjare Exp $
// ----------------------------------------------------------------------
// BOOKS module
// Copyright (C) 2002 by Michael Schatz
// Written by Michael Schatz and Jason Levitt and Olivier Guillet
// Get the newest version at http://sourceforge.net/projects/pn-mod-books
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com
// ----------------------------------------------------------------------

if (!defined("LOADED_AS_MODULE")) {
         die ("You can't access this file directly...");
     }

$ModName = $GLOBALS['name'];
modules_get_language();

include("modules/$ModName/bk-functions.php");
include("modules/$ModName/bk-config.php");

/*--------------------------------------------------------------------------
 * function  CategoryNewBookGraphic
 *--------------------------------------------------------------------------
 * purpose   show a "new" graphic, if new books have been added to category
 * input     $cat : the category to look for
 * output    -
 * changes   Post Nuke Mod -- Modify the CategoryNewBookGraphic($cid) function 
 *              to only show 'new' graphics for the books directly under main 
 *              categories.
 *           2001-09-24 [MS] fixed error with time using (this was stupid)
 *--------------------------------------------------------------------------*/
function CategoryNewBookGraphic($cat) {
    global $pntable;

    $imagesdir=pnModGetVar('books','imagesdir'); 
    $newresult = mysql_query("select date from $pntable[books_books] where cid=$cat order by date desc limit 1");
    if (mysql_num_rows($newresult) == 0) {
     return;
    }
    list($adate) = mysql_fetch_row($newresult);
    echo "&nbsp;";
    setlocale ("LC_TIME", "$locale");
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $adate, $tmpdate);
    $catdate = date("d-M-Y",mktime(0,0,0,$tmpdate[2],$tmpdate[3],$tmpdate[1]));
    $startdate = time();
    $count = 0;
    while ($count <= 7) {
    $daysold = date("d-M-Y", $startdate);
        if ("$daysold" == "$catdate") {
            if ($count<=1) {
        echo "<img src=\"$imagesdir/newred.gif\" alt=\""._CATNEWTODAY."\" border=\"0\">";
        }
            if ($count<=3 && $count>1) {
        echo "<img src=\"$imagesdir/newgreen.gif\" alt=\""._CATLAST3DAYS."\" border=\"0\">";
        }
            if ($count<=7 && $count>3) {
        echo "<img src=\"$imagesdir/newblue.gif\" alt=\""._CATTHISWEEK."\" border=\"0\">";
        }
    }
        $count++;
        $startdate = (time()-(86400 * $count));
    }
} // end CategoryNewBookGraphic

/*--------------------------------------------------------------------------
 * function  SubCategoryNewBookGraphic
 *--------------------------------------------------------------------------
 * purpose   show a "new" graphic, if new books have been added to sub-category
 * input     $sid : SubCategory
 * output    
 * changes   Post-Nuke mod --  Create a the new function for generating the 
 *              'new' graphics for sub-categoires, based on the post-nuke 
 *              CategoryNewBookGraphic($cid) function.
 *           2001-09-24 [MS] fixed error with time using (this was stupid)
 *--------------------------------------------------------------------------*/
function SubCategoryNewBookGraphic($sid) {
    global $pntable;

    $imagesdir=pnModGetVar('books','imagesdir'); 
    $newresult = mysql_query("select date from $pntable[books_books] where sid=$sid order by date desc limit 1");
    if (mysql_num_rows($newresult) == 0) {
     return;
    }
    list($adate)=mysql_fetch_row($newresult);
    echo "&nbsp;";
    setlocale ("LC_TIME", "$locale");
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $adate, $tmpdate);
    $subcatdate = date("d-M-Y",mktime(0,0,0,$tmpdate[2],$tmpdate[3],$tmpdate[1]));
    $startdate = time();
    $count = 0;
    while ($count <= 7) {
        $daysold = date("d-M-Y", $startdate);
        if ("$daysold" == "$subcatdate") {
        if ($count<=1) {
        echo "<img src=\"$imagesdir/newred.gif\" alt=\""._CATNEWTODAY."\" border=\"0\">";
    }
            if ($count<=3 && $count>1) {
        echo "<img src=\"$imagesdir/newgreen.gif\" alt=\""._CATLAST3DAYS."\" border=\"0\">";
    }
            if ($count<=7 && $count>3) {
        echo "<img src=\"$imagesdir/newblue.gif\" alt=\""._CATTHISWEEK."\" border=\"0\">";
    }
}
        $count++;
        $startdate = (time()-(86400 * $count));
    }
} // end SubCategoryNewBookGraphic

/*--------------------------------------------------------------------------
 * function  menu
 *--------------------------------------------------------------------------
 * purpose   write main menu
 * input     mainlink : > 0 writes a link to index page
 * output    -
 * changes   2001-09-21 [MS] show ADDBOOK only for users
 *           2001-11-19 [MS] $menulink defaults to zero
 *--------------------------------------------------------------------------*/
function menu($mainlink) {
    global  $user, $query;
    OpenTable();
    $sn = pnConfigGetVar('sitename');
    $urlinsert=pnModGetVar('books','urlinsert'); 
    $urlinsfunc=pnModGetVar('books','urlinsfunc');   

    echo "<br><center><a class=\"pn-logo\"  href=\"$urlinsert\">$sn -- "._BOOKPAGETITLE."</a><br><br>";
    echo "<form action=\"$urlinsert&amp;req=search&amp;query=$query\" method=\"post\">"
        ."<font class=\"pn-normal\"><input type=\"text\" size=\"25\" name=\"query\" style=\"width:80%\"> <input type=\"submit\" value=\""._SEARCH."\"></font>"
        ."</form>";
    echo "<font class=\"pn-normal\">[ ";

    if ($mainlink > 0) {
    echo "<a class=\"pn-normal\" href=\"$urlinsert\">"._BOOKSMAIN."</a> | ";
    }

    if (pnSecAuthAction(0, 'books::', '::', ACCESS_COMMENT)) {
        echo "<a class=\"pn-normal\" href=\"$urlinsfunc=add_book_form\">"._ADDBOOK."</a> | ";
    }

    echo "<a class=\"pn-normal\" href=\"$urlinsfunc=new_books\">"._NEWBOOKS."</a> | "
        ."<a class=\"pn-normal\" href=\"$urlinsfunc=most_popular\">"._POPULAR."</a> | "
        ."<a class=\"pn-normal\" href=\"$urlinsfunc=top_rated\">"._TOPRATED."</a> | "
        ."<a class=\"pn-normal\" href=\"$urlinsfunc=random_book\">"._RANDOM."</a> ]"
        ."</font></center>";
    CloseTable();
}

/*--------------------------------------------------------------------------
 * function  SearchForm
 *--------------------------------------------------------------------------
 * purpose   write search form to screen
 * input     -
 * output    -
 * changes   -
 *--------------------------------------------------------------------------*/
function SearchForm($query) {
    global $query;

    $urlinsert=pnModGetVar('books','urlinsert');  
    echo "<form action=\"$urlinsert&amp;req=search&query=$query\" method=\"post\">"
    ."<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">"
    ."<tr><td><font class=\"pn-normal\"><input type=\"text\" size=\"25\" name=\"query\"> <input type=\"submit\" value=\""._SEARCH."\"></td></tr>"
    ."</table>"
    ."</form>";
}

/*--------------------------------------------------------------------------
 * function  BookInfoMenu
 *--------------------------------------------------------------------------
 * purpose   write a info-menu for a given book
 * input     bkid   : a book id
 *           ttitle : templated title
 * output    -
 * changes   -
 *--------------------------------------------------------------------------*/
function BookInfoMenu($bkid, $ttitle) {
   
    $urlinsfunc=pnModGetVar('books','urlinsfunc');  
    echo "<br><font class=\"pn-normal\">[ "
    ."<a class=\"pn-normal\" href=\"$urlinsfunc=view_book_comments&amp;bkid=$bkid&amp;ttitle=$ttitle\">"._BOOKCOMMENTS."</a>"
    ." | <a class=\"pn-normal\" href=\"$urlinsfunc=view_book_details&amp;bkid=$bkid&amp;ttitle=$ttitle\">"._RATINGDET."</a>";

    echo " | <a class=\"pn-normal\" href=\"$urlinsfunc=modify_link_request&amp;bkid=$bkid\">"._REQUESTBOOKMOD."</a>";

    echo " | <a class=\"pn-normal\" href=\"$urlinsfunc=broken_link&amp;bkid=$bkid\">"._REPORTBROKEN."</a> ]</font>";
}

/*--------------------------------------------------------------------------
 * function  PopGraphic
 *--------------------------------------------------------------------------
 * purpose   show a graphic for 'popular' links
 * input     $hits
 * output    -
 * changes   -
 *--------------------------------------------------------------------------*/
function PopGraphic($hits) {

    $popular=pnModGetVar('books','popular');
    $imagesdir=pnModGetVar('books','imagesdir'); 

    if ($hits >= $popular) {
        echo "&nbsp;<img src=\"$imagesdir/pop.gif\" alt=\""._POPULAR."\" border=\"0\">";
    }
} // end PopGraphic

/*--------------------------------------------------------------------------
 * function  NewBookGraphic
 *--------------------------------------------------------------------------
 * purpose   print a grafic, if it is a "new" book
 * input     $adate : date to check
 * output    -
 * changes   2001-09-24 [MS] only $adate input, error fixed
 *--------------------------------------------------------------------------*/
function NewBookGraphic($adate) {
    echo "&nbsp;";
    $imagesdir=pnModGetVar('books','imagesdir'); 

    setlocale ("LC_TIME", "$locale");
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $adate, $tmpdate);
    $bookdate = date("d-M-Y",mktime(0,0,0,$tmpdate[2],$tmpdate[3],$tmpdate[1]));
    $startdate = time();
    $count = 0;
    while ($count <= 7) {
        $daysold = date("d-M-Y", $startdate);
        if ("$daysold" == "$bookdate") {
            if ($count<=1) {
                echo "<img src=\"$imagesdir/newred.gif\" alt=\""._NEWTODAY."\" border=\"0\">";
            }
            if ($count<=3 && $count>1) {
                echo "<img src=\"$imagesdir/newgreen.gif\" alt=\""._NEWLAST3DAYS."\" border=\"0\">";
            }
            if ($count<=7 && $count>3) {
                echo "<img src=\"$imagesdir/newblue.gif\" alt=\""._NEWTHISWEEK."\" border=\"0\">";
            }
        }
        $count++;
        $startdate = (time()-(86400 * $count));
    }
}

/*--------------------------------------------------------------------------
 * function  web_links_rateMakeStar
 *--------------------------------------------------------------------------
 * purpose   
 * input     $score
 *           $max_score
 * output    
 * changes   this code is take from harpia project http://sourceforge.net/projects/harpia 
 *--------------------------------------------------------------------------*/
function web_links_rateMakeStar($score, $max_score) { 

    $imagesdir=pnModGetVar('books','imagesdir'); 
    $score /= 2;    
    $max_score /=2;                                 //      5 stars. comment for 10 stars 
    $rateImgFull = ""; 
    $rateImgHalf = "$imagesdir/rate_half.gif"; 
    $rateImgNone = "$imagesdir/rate_none.gif"; 
    
    if (strpos($score,".")==0){                     // Break up score 
        $full_stars=$score; 
    } else { 
        $full_stars=substr($score,0,strpos($score,".")); 
    } 
    
    if (substr($score,strpos($score,".")+1)==0){    // *** Is there half star 
        $half_stars=0; 
    } else { 
        $half_stars=1; 
    } 
    
    $blank_stars=$max_score-($full_stars+$half_stars);  // *** Build Star Line 
    $star_line=""; 
    for ($i=1;$i<=$max_score;$i++){ 
        if ($i<=$full_stars){ 
            $star_line.="<img src=\"$imagesdir/rate_full.gif\" border=\"0\">"; 
        }elseif ($i<=($half_stars+$full_stars)){ 
            $star_line.="<img src=\"$imagesdir/rate_half.gif\" border=\"0\">"; 
        }elseif ($i<=$max_score){ 
            $star_line.="<img src=\"$imagesdir/rate_none.gif\" border=\"0\">"; 
        } 
    } 
    return $star_line; 
} 


/*--------------------------------------------------------------------------
 * function  str_emphasize
 *--------------------------------------------------------------------------
 * purpose   emphasize aword in atext
 * input     $atext     text wich MAY conatain aword
 *           $aword     word to emphasize
 *           $acolor    emphasize color
 * output    -
 * changes   2002-02-15 [MS] introduced
 *--------------------------------------------------------------------------*/
function str_emphasize($atext, $aword="", $acolor="#ffff66") {

    if ($aword < "!") return $atext;        // do nothing if no word is given
    $atext = ereg_replace($aword, "<b style=\"color:black;background-color:".$acolor."\">".$aword."</b>", $atext);
    $aword = strtoupper($aword);
    $atext = ereg_replace($aword, "<b style=\"color:black;background-color:".$acolor."\">".$aword."</b>", $atext);
    $aword = strtolower($aword);
    $atext = ereg_replace($aword, "<b style=\"color:black;background-color:".$acolor."\">".$aword."</b>", $atext);
    $aword = ucfirst($aword);
    $atext = ereg_replace($aword, "<b style=\"color:black;background-color:".$acolor."\">".$aword."</b>", $atext);
    return $atext;
}


/*--------------------------------------------------------------------------
 * function  ShowBook
 *--------------------------------------------------------------------------
 * purpose   write book-content of abkid to screen. Searches in books_books 
 *           for data. this is the place to edit the apearrance of the books. 
 *           the only one.  
 * input     $abkid     the book id to show
 *           $emptext   a text to emphasize
 * output    -
 * changes   2001-09-20 [MS] introduced this central function
 *           2001-09-21 [MS] function enhanced, links to order1..3 added
 *           2001-09-24 [MS] show editorial
 *           2001-10-04 [MS] Categories as a link
 *           2001-11-06 [MS] Better support for Netscape
 *           2002-01-15 [MS] admin edit link added; submitter info added
 *           2002-02-15 [MS] parameter $emptext added; emphasize functionality added
 *--------------------------------------------------------------------------*/
function ShowBook($abkid, $emptext="") {
    global $pntable, $title;

    $imagesdir=pnModGetVar('books','imagesdir'); 
    $booksdir=pnModGetVar('books','booksdir'); 

    $result = mysql_query("select bkid, cid, sid, isbn, title, author, description, date, order1, order2, order3, order4, order5, order6, cover, submitter, hits, bookratingsummary, totalvotes, totalcomments from $pntable[books_books] where bkid = $abkid");

    $numrows = @mysql_num_rows($result);
    $urlinsfunc=pnModGetVar('books','urlinsfunc');  

    $emptyimage=pnModGetVar('books','emptyimage'); 

    if ($numrows == 1) {

        list($bkid, $cid, $sid, $isbn, $title, $author, $description, $time, $order1, $order2, $order3, $order4, $order5, $order6, $cover, $submitter, $hits, $bookratingsummary, $totalvotes, $totalcomments)=mysql_fetch_row($result);

        //Must have read access to see books in category
        if (pnSecAuthAction(0,'books::Category', "$title::$cid", ACCESS_READ))
        {

        $bookratingsummary = number_format($bookratingsummary, $mainvotedecimal);
        $ttitle = $title;
        $title = stripslashes($title); 
        $title = str_emphasize($title, $emptext);
        $author = stripslashes($author); 
        $author = str_emphasize($author, $emptext);
        $description = stripslashes($description);
        $description = str_emphasize($description, $emptext);

    if ($cover == "") {
       $coverimg = $imagesdir.'/'.$emptyimage;
    } else {
       if (stristr($cover, "http")) {
          $coverimg = $cover;
       } else {
          $coverimg = $booksdir.'/'.$cover;
       }
    }

        echo "<!--- Book Details for ID:$abkid --->\n";
        OpenTable();
        echo "<tr valign=\"top\"><td valign=\"top\" rowspan=\"4\"><img src=\"$coverimg\" border=\"0\"></td>\n";
        echo "</tr>\n";
        echo "<tr valign=\"top\"><td valign=\"top\"><font class=\"pn-title\"><b>$title</b></font><font class=\"pn-normal\">\n";
        NewBookGraphic($time);
        PopGraphic($hits);
        echo "<br><br>\n";
        /* get the categories */
        $result2 = mysql_query("select title from $pntable[books_categories] where cid=$cid");
        list($ctitle) = mysql_fetch_row($result2);
        echo "<i>"._CATEGORY." </i>: <a class=\"pn-normal\" href=\"$urlinsfunc=view_cat&amp;cid=$cid\">$ctitle</a>";
        $result3 =mysql_query("select title from $pntable[books_subcategories] where sid=$sid");
        while(list($stitle) = mysql_fetch_row($result3)) {
            echo " / <a class=\"pn-normal\" href=\"$urlinsfunc=view_subcat&amp;sid=$sid\">$stitle</a>";
        }
        echo "</font><br><br>\n";
        echo "<font class=\"pn-normal\"><i>"._BOOKAUTHOR." </i>: $author <br><br>\n";
        echo "<i>"._BOOKISBN." </i>: $isbn <br></td>\n";

        echo "<td valign=\"top\" align=right>";
        if ($order1 > "!") echo "<a class=\"pn-normal\" href=\"$urlinsfunc=visit&amp;bkid=$bkid&amp;orderid=1\" alt=\""._BOOKORDER._ORDER1."\" target=\"new\"><img src=\"$imagesdir/"._BOOKLOGO1."\" border=\"0\" alt=\""._BOOKORDER._ORDER1."\"></a><br>\n";
        if ($order2 > "!") echo "<a class=\"pn-normal\" href=\"$urlinsfunc=visit&amp;bkid=$bkid&amp;orderid=2\" alt=\""._BOOKORDER._ORDER2."\" target=\"new\"><img src=\"$imagesdir/"._BOOKLOGO2."\" border=\"0\" alt=\""._BOOKORDER._ORDER2."\"></a><br>\n";
        if ($order3 > "!") echo "<a class=\"pn-normal\" href=\"$urlinsfunc=visit&amp;bkid=$bkid&amp;orderid=3\" alt=\""._BOOKORDER._ORDER3."\" target=\"new\"><img src=\"$imagesdir/"._BOOKLOGO3."\" border=\"0\" alt=\""._BOOKORDER._ORDER3."\"></a><br>\n";
        if ($order4 > "!") echo "<a class=\"pn-normal\" href=\"$urlinsfunc=visit&amp;bkid=$bkid&amp;orderid=4\" alt=\""._BOOKORDER._ORDER4."\" target=\"new\"><img src=\"$imagesdir/"._BOOKLOGO4."\" border=\"0\" alt=\""._BOOKORDER._ORDER4."\"></a><br>\n";
	  if ($order5 > "!") echo "<a class=\"pn-normal\" href=\"$urlinsfunc=visit&amp;bkid=$bkid&amp;orderid=5\" alt=\""._BOOKORDER._ORDER5."\" target=\"new\"><img src=\"$imagesdir/"._BOOKLOGO5."\" border=\"0\" alt=\""._BOOKORDER._ORDER5."\"></a><br>\n";
	  if ($order6 > "!") echo "<a class=\"pn-normal\" href=\"$urlinsfunc=visit&amp;bkid=$bkid&amp;orderid=6\" alt=\""._BOOKORDER._ORDER6."\" target=\"new\"><img src=\"$imagesdir/"._BOOKLOGO6."\" border=\"0\" alt=\""._BOOKORDER._ORDER6."\"></a><br>\n";

        echo "</td></tr>\n";
        echo "<tr valign=\"top\"><td valign=\"top\" colspan=\"2\"><font class=\"pn-normal\">\n";
        echo "<i>"._DESCRIPTION." </i>: $description<br></font>";

        /* editor review*/
        $result4 = mysql_query("SELECT adminid, editorialtimestamp, editorialtext, editorialtitle FROM $pntable[books_editorials] WHERE bookid = $bkid");
        $recordexist = mysql_num_rows($result4);
        if ($recordexist != 0) {
            while(list($adminid, $editorialtimestamp, $editorialtext, $editorialtitle) = mysql_fetch_row($result4)) {
                $editorialtitle = stripslashes($editorialtitle); 
                $editorialtext  = stripslashes($editorialtext);
                $formatted_date = FormatDateTime(_LINKSDATESTRING,$editorialtimestamp);
                echo "<br><font class=\"pn-normal\"><i>"._BOOKEDITORIAL." </i>: $editorialtitle<br>\n"
                    ."$editorialtext <br>["._BOOKEDITADDED." $formatted_date "._BY." $adminid]</font><br>\n";
            }
        } 
        echo "</font></td></tr>\n";
        $datetime = FormatDateTime(_LINKSDATESTRING, $time);
        echo "<tr><td colspan=\"2\">";

     if ($submitter == "") {
            echo "<font class=\"pn-normal\"><i>"._ADDEDON."</i> : $datetime<br>\n";
     } else {
            echo "<font class=\"pn-normal\"><i>"._ADDEDON."</i> : $datetime <i>"._BY."</i> <a href=\"user.php?op=userinfo&amp;uname=$submitter\" class=\"pn-normal\">$submitter</a><br>\n";
     }

            echo "<i>"._HITS."</i>: $hits";

        /* voting & comments stats */
        if ($totalvotes != 0) {
            $votestring = (($totalvotes == 1) ? "._VOTE." : "._VOTES.");
            if ($bookratingsummary!="0" || $bookratingsummary!="0.0") {
                echo "&nbsp;&nbsp;<i>"._RATING."</i> <a class=\"pn-normal\" href=\"$urlinsfunc=view_book_details&amp;bkid=$bkid&ttitle=$ttitle\">"._DETAILSP."</a>: ".web_links_rateMakeStar($bookratingsummary, 10)."&nbsp;\n";
            }
        }

        if ($totalcomments != 0) {
            echo "&nbsp;&nbsp;<a class=\"pn-normal\" href=\"$urlinsfunc=view_book_comments&amp;bkid=$bkid&ttitle=$ttitle\">"._SCOMMENTS." ($totalcomments)</a>&nbsp;&nbsp;\n";
        }

       
        echo "<br>\n";

        //Only show menu options if permissions are sufficient

        if (pnSecAuthAction(0,'books::', '::', ACCESS_COMMENT)) {
        echo "<a class=\"pn-normal\" href=\"$urlinsfunc=rate_book&amp;bkid=$bkid\">"._RATEBOOK."</a>\n";

        echo "|&nbsp;<a class=\"pn-normal\" href=\"$urlinsfunc=modify_link_request&amp;bkid=$bkid\">"._REQUESTBOOKMOD."</a>&nbsp;|\n";

        }

        if (pnSecAuthAction(0,'books::', '::', ACCESS_READ)) {
        echo "<a class=\"pn-normal\" href=\"$urlinsfunc=broken_link&amp;bkid=$bkid\">"._REPORTBROKEN."</a>\n";
        }

        echo "</font></td></tr>\n";
        CloseTable();
        echo "<br>\n";

      } /* close authorization */
    }
}

/*--------------------------------------------------------------------------
 * function  index
 *--------------------------------------------------------------------------
 * purpose   build index page (start page of module books)
 * input     bkid   : a book id
 *           ttitle : templated title
 * output    -
 * changes   2001-09-24 [MS] made category listing more readable
 *           2001-10-02 [MS] show a book on index page, if bkid is set
 *--------------------------------------------------------------------------*/
function index($bkid, $ttitle) {
    global $pntable, $query, $ModName;
    include("header.php");

    $urlinsfunc=pnModGetVar('books','urlinsfunc');  
    $imagesdir=pnModGetVar('books','imagesdir');  
    $booksdir=pnModGetVar('books','booksdir');  
    $emptyimage=pnModGetVar('books','emptyimage');  
    $tablecolor=pnModGetVar('books','tablecolor');  
    $barcolor=pnModGetVar('books','barcolor');  
    $showsubcat=pnModGetVar('books','showsubcat');  
    $books_showed=pnModGetVar('books','books_showed');  
    $showlastbooks=pnModGetVar('books','showlastbooks');  

  //This routine may be called with a bkid from 
  //admin.php to show a user's book view

    if (isset($bkid)) {
        menu(1);
        ShowBook($bkid);
    } else {
    menu(0);
    OpenTable();
    echo "<center><font class=\"pn-title\">"._BOOKSMAINCAT."</font></center><br>";
    echo "<table width=\"100%\" border=\"0\" cellspacing=\"30\" cellpadding=\"0\" align=\"center\">
        <tr>
           <td valign=\"top\" width=\"50%\">
           <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" align=\"center\">";

    $result = mysql_query("select cid, title, cdescription from $pntable[books_categories] order by title");
    $result0 = mysql_query("select COUNT(*) from $pntable[books_categories] order by title");
    list($firstcatnum) = mysql_fetch_row($result0);
    $count = 0;
    $break = 0;
    while(list($cid, $title, $cdescription) = mysql_fetch_row($result)) {
        /* Get a quick count - Wandrer */
        $cresult = mysql_query("select count(*) as count from $pntable[books_books] where cid=$cid");
        $cnumrows = mysql_result($cresult,0,"count");
    
        //Must have read access to Category to see it
        if (pnSecAuthAction(0,'books::Category', "$title::$cid", ACCESS_READ)) 
        {
        echo "<tr><td valign=\"bottom\" height=\"18\"><br>
              <img src=\"$imagesdir/cat.gif\" align=\"absMiddle\" border=\"0\">
              <a class=\"pn-title\" href=\"$urlinsfunc=view_cat&amp;cid=$cid\"><b>$title</b></a> ";
              CategoryNewBookGraphic($cid);
        echo "</td><td align=\"center\" width=\"30\"><br><font class=\"pn-normal\">(<b>$cnumrows</b>)</font></td><tr>";
        if ($description) {
            echo "<tr><td colspan=\"2\"><font class=\"pn-normal\">$cdescription</font><br></td></tr>";
        } 

        /* Post-Nuke Mod -- remove limit of three sub-cats. */
        $result2 = mysql_query("select sid, title from $pntable[books_subcategories] where cid=$cid order by title");
        /* End Mod */

        $space = 0;
        if ($showsubcat == 1) {
        while(list($sid, $stitle) = mysql_fetch_row($result2)) {
        $cresult2 = mysql_query("select count(*) as count from $pntable[books_books] where sid=$sid");
        $cnumrows2 = mysql_result($cresult2,0,"count");

            echo "<tr bgcolor=\"$tablecolor\"><td height=\"18\"><img src=\"$imagesdir/pixel.gif\" align=\"absMiddle\" border=\"0\" width=\"15\" height=\"10\">
                  <a class=\"pn-normal\" href=\"$urlinsfunc=view_subcat&amp;sid=$sid\">$stitle</a>";
                  SubCategoryNewBookGraphic($sid);
            echo "</td><td align=\"center\" width=\"30\"><font class=\"pn-normal\">$cnumrows2</font><td></tr>";
            $space++;
            }
        }

         if ($count >= (($firstcatnum/2)-1)) {
         $break++;
         }

         if ($break == 1) {
         echo "</table></td>
           <td valign=\"top\" width=\"50%\">
           <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" align=\"center\">";
         }

     } /* end pnSecAuth  */
    $count++;
    }  /* end while */
           echo "</table>
               </td>";
    if ($showlastbooks == 1) {

               echo "<td>";
               echo "<table width=\"140\" border=\"0\" cellspacing=\"5\" cellpadding=\"1\" align=\"center\">
    		     <tr>
      		 <td valign=\"top\" align=\"left\" height=\"15\" colspan=\"2\">
        		 <table cellspacing=\"0\" cellpadding=\"1\" width=\"140\" border=\"0\">
                     <tr>";

                     if ($books_showed == 1) {
                       echo "<td align=\"left\"><img src=\"$imagesdir/cat.gif\" align=\"absMiddle\" border=\"0\"> <span class=\"pn-title\">"._MOSTRECENTBOOK."</span></td>";
                     } else {
                       echo "<td align=\"left\"><img src=\"$imagesdir/cat.gif\" align=\"absMiddle\" border=\"0\"><span class=\"pn-title\"> $books_showed "._LASTBOOKS."</span></td>";
                     }

               echo "</tr>
                   </table>
                   </td>
                 </tr>
                 <tr>
                   <td align=\"middle\" bgcolor=\"$barcolor\" colspan=\"2\"><img src=\"$imagesdir/pixel.gif\" align=\"absMiddle\" border=\"0\" width=\"1\" height=\"1\"></td>
                 </tr>";
            $a = 1;
            $result = mysql_query("select bkid, title, cover from $pntable[books_books] $catselect $subcatselect order by date DESC limit 0,$books_showed");
            while(list($id, $title, $cover) = mysql_fetch_row($result)) {
            $title2 = ereg_replace("_", " ", $title);
            if(strlen($title2) > 50) { // Limit title length to avoid wrap
               $title2= strip_tags($title2, '<a><i><b><ul><li>');
               $title2 = substr($title2,0,50);
               $title2 .= "...";
	      }
	      $transfertitle = ereg_replace (" ", "_", $title);

   		if ($cover == "") {
       		$coverimg = $imagesdir.'/'.$emptyimage;
    		} else {
       		if (stristr($cover, "http")) {
          		  $coverimg = $cover;
       		} else {
          		  $coverimg = $booksdir.'/'.$cover;
       		}
    		}

            $content .= "<tr valign=\"top\"><td width=\"5\"></td>
                         <td bgcolor=\"$tablecolor\" align=\"center\" valign=\"top\" width=\"130\"><a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;bkid=$id&amp;ttitle=$transfertitle\"><img src=\"$coverimg\" border=\"0\" align=\"center\"></a></td></tr>
                         <tr><td bgcolor=\"$tablecolor\" width=\"5\"><img src=\"$imagesdir/middot.gif\" align=\"absMiddle\" border=\"0\"></td>
                         <td bgcolor=\"$tablecolor\" align=\"center\" valign=\"top\" width=\"130\"><a class=\"pn-title\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;bkid=$id&amp;ttitle=$transfertitle\">$title</a></td></tr><tr><td></td></tr>";
            $a++;
            }
           echo "$content";
           echo "</table></td>";

    } //end if showlastbooks

       echo "</tr></table>";


    /* Get a quick count - Wandrer */
    $result = mysql_query("select count(*) as count from $pntable[books_books]");
    $numrows = mysql_result($result,0,"count");

    $result = mysql_query("select count(*) as count from $pntable[books_categories]");
    $catnum1 = mysql_result($result,0,"count");

    $result = mysql_query("select count(*) as count from $pntable[books_subcategories]");
    $catnum2 = mysql_result($result,0,"count");

    $catnum = $catnum1 + $catnum2;

    if ($numrows == 1) {
    echo "<br><br><center><font class=\"pn-sub\">"._THEREIS." <b>$numrows</b> "._BOOK." "; 
    } else {
    echo "<br><br><center><font class=\"pn-sub\">"._THEREARE." <b>$numrows</b> "._BOOKS." ";
    }

    if ($catnum == 1) {
     echo    ""._AND." <b>$catnum</b> "._CATEGORY." "._INDB."</font></center>";
    } else {
      echo ""._AND." <b>$catnum</b> "._CATEGORIES." "._INDB."</font></center>";
    }

   }

    if (isset($bkid)) {
    } else {
    CloseTable();
    }
    include("footer.php");
} // end index



/*--------------------------------------------------------------------------
 * function  search
 *--------------------------------------------------------------------------
 * purpose   search in database for a book
 * input     $query   : the phrase to search for
 *           $min     : the starting page
 *           $orderby : the ordering
 *           $show    : the number of entries to show
 * output    -
 * changes   2001-09-25 [MS] made it all working ...
 *           2001-11-16 [MS] dropped include(config.php). This is loaded by mainfile.php !
 *           2002-02-13 [MS] making searchfunction realy working
 *           2002-02-15 [MS] mark results in output
 *           2002-10-07 [MS] preventing input string exploit
 *--------------------------------------------------------------------------*/
function search($query, $min, $orderby, $show) {
    global $admin, $bgcolor2, $pntable;
  
    $urlinsfunc=pnModGetVar('books','urlinsfunc');   
    $urlinsert=pnModGetVar('books','urlinsert');   
    $booksresults=pnModGetVar('books','booksresults'); 
    $booksperpage=pnModGetVar('books','booksperpage');
    $imagesdir=pnModGetVar('books','imagesdir'); 

    $myhref = "<a class=\"pn-normal\" href=\"$urlinsert&amp;req";
    if (!isset($min)) $min=0;
    if (!isset($max)) $max=$min + $booksresults;
    if(isset($orderby)) {
        $orderby = ConvertOrderByIN($orderby);
    } else {
        $orderby = "title ASC";
    }
    if ($show != "") {
        $booksresults = $show;
    } else {
        $show = $booksresults;
    }
    $query = stripslashes($query);
    $transferquery = str_replace (" ", "+", $query);

    // prevent query exploit
    $outquery = htmlspecialchars($query);

/*  use this for further enhancement of the search process */
    $query_array = explode("+",$query);

    // check if there are any results
    $fullcountresult1 = mysql_query("select count(*) as count from $pntable[books_books] where title LIKE '%$query%' or author LIKE '%$query%' or description LIKE '%$query%' ");
    $fullcount1 = mysql_result($fullcountresult1,0,"count");
    $fullcountresult2 = mysql_query("select count(*) as count from $pntable[books_subcategories] where title LIKE '%$query%' ");
    $fullcount2 = mysql_result($fullcountresult2,0,"count");
    if ($fullcount1 > 0) {
        $searchresult = mysql_query("select bkid from $pntable[books_books] where title LIKE '%$query%' or author LIKE '%$query%' or description LIKE '%$query%' ");
        $searchrows  = mysql_num_rows($searchresult);
		if ($fullcount2 > 0) {
            // check if search query is in subcategorie names
    		$catrowsresult = mysql_query("select cid, sid, title from $pntable[books_subcategories] where title LIKE '%$query%' ORDER BY title DESC");
    		$catrows = mysql_num_rows($catrowsresult);
            }
    } else {
		if ($fullcount2 > 0) {
            // check if search query is in subcategorie names
    		$catrowsresult = mysql_query("select cid, sid, title from $pntable[books_subcategories] where title LIKE '%$query%' ORDER BY title DESC");
    		$catrows = mysql_num_rows($catrowsresult);
            }
        $searchrows = 0;
    }

    $x=0;
    include("header.php");
    menu(1);
    echo "<br>";
    OpenTable();
    if ($query != "")  {
        if (($searchrows > 0) or ($catrows > 0)) {
            echo "<font class=\"pn-normal\">"._SEARCHRESULTS4.": <b>$outquery</b></font><br><br>";
            if ($catrows > 0) {
                echo "<table width=\"100%\" bgcolor=\"$bgcolor2\"><tr><td><font class=\"pn-normal\"><b>"._USUBCATEGORIES."</b></font></td></tr></table>";
                while(list($cid, $sid, $stitle) = mysql_fetch_row($catrowsresult)) {
                    $cate = mysql_query("select title from $pntable[books_categories] where cid=$cid");
                    list($ctitle) = mysql_fetch_row($cate);
                    /* Get a quick count - Wandrer */
                    $res = mysql_query("select count(*) as count from $pntable[books_books] where sid=$sid");
                    $numrows = mysql_result($res,0,"count");
                    $ctitle = ereg_replace($query, "<B style=\"color:black;background-color:#ffff66\">".$query."</B>", $ctitle);
                    $stitle = ereg_replace($query, "<B style=\"color:black;background-color:#ffff66\">".$query."</B>", $stitle);
                    echo "<font class=\"pn-normal\"><strong><big>&middot;</big></strong>&nbsp;<a class=\"pn-normal\" href=\"$urlinsfunc=view_subcat&amp;sid=$sid\">$ctitle / $stitle</a> ($numrows)<br></font>";
                }
                echo "<br>";
            }
  
            echo "<table width=\"100%\" bgcolor=\"$bgcolor2\"><tr><td><font class=\"pn-normal\"><b>"._BOOKS."</b></font></td></tr></table>";
            if ($searchrows > 0) {
            $orderbyTrans = ConvertOrderByTRANS($orderby);
            echo "<br><font class=\"pn-normal\">"._SORTBOOKSBY.": "
                ."|&nbsp;$myhref=search&amp;query=$query&amp;orderby=titleA\"><img hspace=\"4\" src=\"$imagesdir/up.gif\" border=\"0\">"._TITLE."</a>$myhref=search&amp;query=$query&amp;orderby=titleD\"><img hspace=\"4\" src=\"$imagesdir/down.gif\" border=\"0\"></a>&nbsp;"
                ."|&nbsp;$myhref=search&amp;query=$query&amp;orderby=dateA\"><img hspace=\"4\" src=\"$imagesdir/up.gif\" border=\"0\"></a>$myhref=search&amp;query=$query&amp;orderby=dateD\">"._DATE."<img hspace=\"4\" src=\"$imagesdir/down.gif\" border=\"0\"></a>&nbsp;"
                ."|&nbsp;$myhref=search&amp;query=$query&amp;orderby=ratingA\"><img hspace=\"4\" src=\"$imagesdir/up.gif\" border=\"0\"></a>$myhref=search&amp;query=$query&amp;orderby=ratingD\">"._RATING."<img hspace=\"4\" src=\"$imagesdir/down.gif\" border=\"0\"></a>&nbsp;"
                ."|&nbsp;$myhref=search&amp;query=$query&amp;orderby=hitsA\"><img hspace=\"4\" src=\"$imagesdir/up.gif\" border=\"0\"></a>$myhref=search&amp;query=$query&amp;orderby=hitsD\">"._POPULARITY."<img hspace=\"4\" src=\"$imagesdir/down.gif\" border=\"0\"></a>&nbsp;"
                ."|<br><br>"._BOOKSSORTED.": $orderbyTrans<br><br>";
            
            while(list($bkid) = mysql_fetch_row($searchresult)) {
                ShowBook($bkid, $transferquery);
                echo "<br>";
                $x++;
            }
            echo "</font>";
            $orderby = ConvertOrderByOUT($orderby);

            /* Calculates how many pages exist.  Which page one should be on, etc... */
            $bookpagesint = ($fullcount / $booksperpage);
            $bookpageremainder = ($fullcount % $booksresults);
            if ($bookpageremainder != 0) {
                $bookpages = ceil($bookpagesint);
                if ($fullcount < $booksresults) {
                    $bookpageremainder = 0;
                    }
                } else {
                    $bookpages = $bookpagesint;
                }
            /* Page Numbering */
            if ($bookpages != 1 && $bookpages != 0) {
                echo "<br><br><font class=\"pn-normal\">"
                    .""._SELECTPAGE.": ";
                $prev = $min - $booksresults;
                if ($prev >= 0) {
                    echo "&nbsp;&nbsp;<b>[ $myhref=search&amp;query=$query&amp;min=$prev&amp;orderby=$orderby&amp;show=$show\">"
                        ." &lt;&lt; "._PREVIOUS."</a> ]</b> ";
                }
                $counter = 1;
                $currentpage = ($max / $booksresults);
                while ($counter <= $bookpages ) {
                    $cpage = $counter;
                    $mintemp = ($booksperpage * $counter) - $booksresults;
                    if ($counter == $currentpage) {
                        echo "<b>$counter</b> ";
                    } else {
                        echo "$myhref=search&amp;query=$query&amp;min=$mintemp&amp;orderby=$orderby&amp;show=$show\">$counter</a> ";
                    }
                    $counter++;
                }
                $next = $min + $booksresults;
                if ($x >= $booksperpage) {
                    echo "&nbsp;&nbsp;<b>[ $myhref=search&amp;query=$query&amp;min=$max&amp;orderby=$orderby&amp;show=$show\">"
                        ." "._NEXT." &gt;&gt;</a> ]</b>";
                }
                echo "</font>\n";
                }
            } else {
            echo "<br><br><center><font class=\"pn-normal\"><b>\"$outquery\"<br>"._NOMATCHES."</b></font><br><br>"._GOBACK."<br></center>";
            }
        } else {
            echo "<br><br><center><font class=\"pn-normal\"><b>\"$outquery\"<br>"._NOMATCHES."</b></font><br><br>"._GOBACK."<br></center>";
        }

        echo "<br><center><font class=\"pn-normal\">"
            .""._TRY2SEARCHBOOKS." \"$outquery\" "._INOTHERENGINES."<br>"
            ."<a class=\"pn-normal\" target=\"_blank\" href=\"http://www.altavista.com/cgi-bin/query?pg=q&amp;sc=on&amp;hl=on&amp;act=2006&amp;par=0&amp;q=$transferquery&amp;kl=XX&amp;stype=stext\">Alta Vista</a> - "
            ."<a class=\"pn-normal\" target=\"_blank\" href=\"http://www.google.com/search?q=$transferquery\">Google</a> - "
            ."<a class=\"pn-normal\" target=\"_blank\" href=\"http://search.yahoo.com/bin/search?p=$transferquery\">Yahoo</a>"
            ."</font>";
    } else {
        
        echo "<center><font class=\"pn-normal\"><b>"._EMPTYQUERY."</b></font></center><br><br>";
    }
    CloseTable();
    include("footer.php");
} // end Search


if (!pnSecAuthAction(0, 'books::', '::', ACCESS_READ)) {
        echo _BOOKSNOACCESS;
        include 'footer.php';
        return;
    }

switch($req) {

    case "search":
    include_once("modules/$ModName/bk-showdetails.php");
    search($query, $min, $orderby, $show);
    break;

    case "rate_book":
    include_once("modules/$ModName/bk-modbooks.php");
    RateBook($bkid,$ttitle);
    break;

    case "add_book_form":
    include_once("modules/$ModName/bk-modbooks.php");
    AddBookForm();
    break;

    case "add_book":
    include_once("modules/$ModName/bk-modbooks.php");
    AddBook($title, $author, $isbn, $cat, $description, $nname, $email);
    break;

    case "add_rating":
    include_once("modules/$ModName/bk-modbooks.php");
    AddRating($ratingbkid, $ratinguser, $rating, $ratinghost_name, $ratingcomments,$user);
    break;

    case "broken_link":
    include_once("modules/$ModName/bk-modbooks.php");
    BrokenLink($bkid);
    break;

    case "broken_link_submit":
    include_once("modules/$ModName/bk-modbooks.php");
    BrokenLinkSubmit($bkid, $modifysubmitter);
    break;

    case "modify_link_request":
    include_once("modules/$ModName/bk-modbooks.php");
    ModifyLinkRequest($bkid);
    break;

    case "modify_link_submit":
    include_once("modules/$ModName/bk-modbooks.php");
    ModifyLinkSubmit($bkid, $cat, $title, $author, $description, $modifysubmitter);
    break;

    case "view_book_comments":
    include_once("modules/$ModName/bk-showdetails.php");
    ViewBookComments($bkid,$ttitle);
    break;

    case "view_book_details":
    include_once("modules/$ModName/bk-showdetails.php");
    ViewBookDetails($bkid,$ttitle);
    break;

    case "random_book":
    include_once("modules/$ModName/bk-showcat.php");
    RandomBook();
    break;

    case "view_subcat":
    include_once("modules/$ModName/bk-showcat.php");
    ViewSubCat($sid, $min, $orderby, $show);
    break;

    case "view_cat":
    include_once("modules/$ModName/bk-showcat.php");
    ViewCat($cid, $min, $orderby, $show);
    break;

    case "new_books":
    include_once("modules/$ModName/bk-showcat.php");
    NewBooks($newbookshowdays);
    break;

    case "new_books_date":
    include_once("modules/$ModName/bk-showcat.php");
    NewBooksDate($selectdate);
    break;

    case "top_rated":
    include_once("modules/$ModName/bk-showcat.php");
    TopRated($ratenum, $ratetype);
    break;

    case "most_popular":
    include_once("modules/$ModName/bk-showcat.php");
    MostPopular($ratenum, $ratetype);
    break;

    case "visit":
    visit($bkid, $orderid);
    break;

    default:
    index($bkid, $ttitle);
    break;
}

?>
