<?php
// ------------------------------------------------------------------------------------
// Translation for Photoshare PostNuke Module
// Language:              English
// Translation by:        Jorn Lind-Nielsen
// ------------------------------------------------------------------------------------
define('_CONFIRM', 'Ok');  /* Used by pnHTML */
define('_PSACCESSPRIVATE', 'The album is private and may not be viewed by others.');
define('_PSACCESSALLREAD', 'Everybody can view the album.');
define('_PSACCESSALLWRITE', 'Everybody can view and edit the album.');
define('_PSACCESSDETAILED', 'Selected users can view and edit the album as specified below.');
define('_PSADMINIMPORTLINK1', 'As administrator you may import files from the web-server\'s file system ');
define('_PSADMINIMPORTLINK2', 'here');
define('_PSAPILOADFAILED', 'Could not load Photoshare API');
define('_PSBACK', 'Back');
define('_PSBACKTOFOLDER', 'Back to album');
define('_PSBADAUTHKEY', 'Wrong authentication code - you can only submit a page one time');
define('_PSBLOCKFROMLIST', 'Do not show album in list of all albums');
define('_PSBYTES', 'bytes');
define('_PSCANCEL', 'Cancel');
define('_PSCANNOTADDIMAGESWITHOUTFOLDER', 'You have not selected an album for the images');
define('_PSCAPACITYUSED', 'Storage: ');
define('_PSCHANGEACCESS', 'Publish album');
define('_PSCONFIRMFOLDERDELETE', 'You are deleting the album');
define('_PSCONFIRMFOLDERDELETESINGLE', 'Delete only the album and move all sub-albums to parent album.');
define('_PSCONFIRMFOLDERDELETESUB', "Delete album and all it's sub-albums.");
define('_PSCONFIRMIMAGEDELETE', 'You are deleting the image');
define('_PSCONFIRMMULTIDELETE', 'Delete all selected images?');
define('_PSCONTINUE', 'Continue');
define('_PSCURRENTDIRIS', 'Current directory is: ');
define('_PSDELETEFOLDER', 'Delete album');
define('_PSDELETEIMAGE', 'Delete image');
define('_PSDSTFOLDER', 'Image album');
define('_PSEDITIMAGE', 'Edit image');
define('_PSEDITFOLDER', 'Edit album');
define('_PSEMPTYALBUM', 'There are no images in this album.');
define('_PSERROR', 'Error');
define('_PSFINDIMAGE', 'Find Photoshare Image');
define('_PSFINDSELECT', 'Select');
define('_PSFOLDER', 'Album');
define('_PSFOLDERS', 'Albums');
define('_PSDEFAULTFOLDERTEMPLATE', 'Default album template');
define('_PSFOLDERTITLE', 'Title');
define('_PSFOLDERDESCRIPTION', 'Description');
define('_PSFOLDERTOPIC', 'Topic');
define('_PSGROUPACCESS', 'Groups that have access to this album');
define('_PSGROUPS', 'Groups');
define('_PSHASREADACCESS', 'View-access to album');
define('_PSHASWRITEACCESS', 'Edit-access to album');
define('_PSHIDEPNFRAME', 'Hide PostNuke frame when displaying images');
define('_PSIMAGE', 'Image');
define('_PSIMAGEDESCRIPTION', 'Description');
define('_PSIMAGEFILE', 'Image file');
define('_PSIMAGECOUNT', 'Number of images');
define('_PSIMAGENO', 'Image no.');
define('_PSIMAGETITLE', 'Title');

define('_PSINSERTIMAGE', 'Insert');
define('_PSINSFULLIMAGE', 'Full image');
define('_PSINSTHUMBNAIL', 'Thumbnail');
define('_PSINSTHUMBNAILPOPUP', 'Thumbnail (image popup)');
define('_PSINSFULLIMAGEURL', 'Full image link');
define('_PSINSFULLIMAGEURLPOPUP', 'Full image link (popup)');
define('_PSINSALBUMURL', 'Album link');
define('_PSINSALBUMURLTHUMBNAIL', 'Album link as thumbnail');
define('_PSINSALBUMURLPOPUP', 'Album link (popup)');
define('_PSINSALBUMURLTHUMBNAILPOPUP', 'Album link as thumbnail (popup)');

define('_PSCURRENTDIRIS', 'Current directory is: ');
define('_PSIMPORTHEADER', 'Import images');
define('_PSIMPORTDIRECTORY', 'Enter name of directory in filesystem from which the images should be imported.');
define('_PSIMPORTSUBMIT', 'Import');

define('_PSISMAINIMAGE', 'This is the album representation image');

define('_PSMAILFOLDER', 'Invite persons by e-mail (sends a special password to the recipients so you do not have to publish your album for everybody).');
define('_PSMAILFOLDERSHORT', 'Invite persons by e-mail.');
define('_PSMAILLETTERTEXT', 'Click here to see the images: ');
define('_PSMAILRECIPIENTS', 'Recipients:');
define('_PSMAILSENDER', 'Sender:');
define('_PSMAILSUBJECT', 'Subject:');
define('_PSMAILSUBMIT', 'Send');
define('_PSMAILWARNING', '<i>Please note that your recipients are also given view access to the subalbums of this album.</i>');

define('_PSMAXFILESIZEMSG', 'Your web server does not allow upload of more than');
define('_PSMEGABYTES', 'Mb');

define('_PSMENUADDFOLDER', 'Add album');
define('_PSMENUADDIMAGES', 'Add images');
define('_PSMENUFOLDERDELETE', 'Delete album');
define('_PSMENUFOLDEREDIT', 'Edit album');
define('_PSMENUTHISFOLDER', 'Edit');
define('_PSMENUVIEWFOLDER', 'Show album');
define('_PSMENUMYFOLDERS', 'My albums');
define('_PSMENUPUBLISHALBUM', 'Publish album');
define('_PSMENUVIEWALLFOLDERS', 'All albums');

define('_PSCREATEDATE', 'Created');
define('_PSMOVEIMAGETOTARGET', 'Move selected image here');
define('_PSMOVEONLYONE', 'Only one image can be moved at a time');
define('_PSMUSTBELOGGEDIN', 'You cannot edit albums without being logged in!');
define('_PSNEXTPAGE', 'Next page >>');
define('_PSNEWIMAGEFILE', 'Optional new image');
define('_PSNOAUTH', 'You do not have access to this function');
define('_PSNOIMAGES', 'No files found in upload');
define('_PSNONE', 'none');
define('_PSNOFOLDERS', 'No albums');
define('_PSNOTOPIC', '- None -');
define('_PSOF', 'of');
define('_PSOK', 'Ok');
define('_PSOPTIONS', 'Actions');

define('_PSORDERBY',       'Order by');
define('_PSORDERBYTITLE',  'Title');
define('_PSORDERBYOWNER',  'Owner');
define('_PSORDERBYDATE',   'Date');
define('_PSORDERBYTOPIC',  'Topic');

define('_PSOWNER', 'Owner');
define('_PSPREVPAGE', 'Previous page >>');
define('_PSPUBLISHHELP', 'The permissions below are used independently of the choices above. This means you can make an album "viewable by everybody" and in addition to this make it editable by some specific users.');
define('_PSROTATECCIMAGE', 'Rotate counter clockwise');
define('_PSROTATECIMAGE', 'Rotate clockwise');

define('_PSSELECTEDDELETE', 'Delete selected images');
define('_PSSELECTEDROTATEC', 'Rotate selected images clockwise');
define('_PSSELECTEDROTATECC', 'Rotate selected images counter clockwise');
define('_PSSELECTEDCOPY', 'Copy selected images');
define('_PSSELECTEDCUT', 'Cut selected images');
define('_PSSELECTEDPASTE', 'Paste images');
define('_PSSELECTEDRECALC', 'Recalculate thumbnails');

define('_PSSELECTACCESS', 'Please specify access to this album');
define('_PSSELECTIMAGE', '(shift/ctrl-)click to select');
define('_PSSELECTTARGETIMAGE', 'Please select image(s) first');
define('_PSSETMAINIMAGE', 'Set image as main image');
define('_PSSHOWIMAGES', 'Slideshow');
define('_PSSUBMITIMAGES', 'Add');
define('_PSSUBMITADD', 'Add');
define('_PSSUBMITEDIT', 'Update');
define('_PSTEMPLATEINFO', 'Template description');
define('_PSTITLE', 'Title');

define('_PSTITLEADDFOLDER', 'Add album');
define('_PSTITLEADDIMAGES', 'Add images to album');
define('_PSTITLEADDINGIMAGES', 'Adding images to album');
define('_PSTITLEDELETEFOLDER', 'Delete album');
define('_PSTITLEDELETEIMAGE', 'Delete image');
define('_PSTITLEEDITFOLDER', 'Edit album');
define('_PSTITLEEDITIMAGE', 'Edit image');
define('_PSTITLEMAILFOLDER', 'Invite by e-mail');
define('_PSTITLEMYFOLDERS', 'My Albums');
define('_PSTITLEVERIFYINGIMPORT', 'Verifying import');

define('_PSTITLEVIEWFOLDERS', 'Album');
define('_PSTITLEVIEWALLFOLDERS', 'Available albums');
define('_PSTOPFOLDERNAME', '(no album selected)');
define('_PSUNKNOWNFOLDER', 'Unknown album');
define('_PSUNKNOWNIMAGE', 'Unknown image');
define('_PSUNKNOWNTEMPLATE', 'Unknown template');
define('_PSUPLOADERROR_INISIZE', 'Upload error - image size exceeds server upload limit');
define('_PSUPLOADERROR_FORMSIZE', 'Upload error - image size exceeds form upload limit');
define('_PSUPLOADERROR_PARTIAL', 'Upload error - uploaded file was only partially uploaded');
define('_PSUPLOADERROR_NOFILE', 'Upload error - no file was uploaded');
define('_PSUPLOADERROR_UNKNOWN', 'Unknown upload error');
define('_PSUPLOADHEADER', 'Upload billeder');
define('_PSUSERACCESS', 'Users with access to this album');
define('_PSUSERS', 'Users');
define('_PSVIEWFOLDER', 'Show album');
define('_PSVIEWIMAGE', 'Show image');
?>