<?php
// $Id: pntables.php
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Chestnut ! http://www.pnconcept.com
// Purpose of file:  Table information for pncGroups Add-On v0.1
// ----------------------------------------------------------------------

function pncgroups_pntables()
{
    // Initialise table array
    $pntable = array();

    // Name for quotes database entities
    $pncgroups = pnConfigGetVar('prefix') . '_pncgroups';
    $pncgroups_pending = pnConfigGetVar('prefix') . '_pncgroups_pending';

    // Table name
    $pntable['pncgroups'] = $pncgroups;
    $pntable['pncgroups_pending'] = $pncgroups_pending;

    // Column names
    $pntable['pncgroups_column'] = array('gid'          => $pncgroups . '.pn_gid',
                                         'type'         => $pncgroups . '.pn_type',
                                         'description'  => $pncgroups . '.pn_description',
                                         'gprefix'      => $pncgroups . '.pn_gprefix',
                                         'gopen'	=> $pncgroups . '.pn_gopen',
                                         'gnbuser'      => $pncgroups . '.pn_gnbuser',
                                         'gnbumax'      => $pncgroups . '.pn_gnbumax',
                                         'link'         => $pncgroups . '.pn_link',
                                         'uidmaster'    => $pncgroups . '.pn_uidmaster',
                                         'gmoderated'   => $pncgroups . '.pn_gmoderated');

    // Column Names for Pending Membership Changes
    $pntable['pncgroups_pending_column'] = array('gid' => $pncgroups_pending . '.pn_gid',
                                                 'uid' => $pncgroups_pending . '.pn_uid');

    // Return table information
    return $pntable;
}

?>
