<?php // $Id: pntables.php,v 1.1.1.1 2004/05/06 03:58:37 dyksjare Exp $
// ----------------------------------------------------------------------
// Publications module
// Copyright (C) 2004 by Jared Dykstra
// Written by Jared Dykstra
// Get the newest version at http://shef.ca
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com
// ----------------------------------------------------------------------

/**
 * This function is called internally by the core whenever the module is
 * loaded.  It adds in the information
 */
function publications_pntables()
{
    // Initialise table array
    $pntable = array();

    // Table Prefix
    $prefix = pnConfigGetVar('prefix') . '_publications';

    // Set the table and column information

$publications_categories = $prefix . '_categories';
$pntable['publications_categories'] = $publications_categories;
$pntable['publications_categories_column'] = array ('cid'          => $publications_categories . '.pn_cid',
                                                  'title'        => $publications_categories . '.pn_title',
                                                  'cdescription' => $publications_categories . '.pn_description');

$publications_downloads = $prefix . '_downloads';
$pntable['publications_downloads'] = $publications_downloads;
$pntable['publications_downloads_column'] = array ('lid'                   => $publications_downloads . '.pn_lid',
                                                'cid'                   => $publications_downloads . '.pn_cid',
                                                'sid'                   => $publications_downloads . '.pn_sid',
                                                'title'                 => $publications_downloads . '.pn_title',
                                                'url'                   => $publications_downloads . '.pn_url',
                                                'description'           => $publications_downloads . '.pn_description',
                                                'date'                  => $publications_downloads . '.pn_date',
                                                'name'                  => $publications_downloads . '.pn_name',
                                                'email'                 => $publications_downloads . '.pn_email',
                                                'hits'                  => $publications_downloads . '.pn_hits',
                                                'submitter'             => $publications_downloads . '.pn_submitter',
                                                'downloadratingsummary' => $publications_downloads . '.pn_ratingsummary',
                                                'totalvotes'            => $publications_downloads . '.pn_totalvotes',
                                                'totalcomments'         => $publications_downloads . '.pn_totalcomments',
                                                'filesize'              => $publications_downloads . '.pn_filesize',
                                                'version'               => $publications_downloads . '.pn_version',
                                                'homepage'              => $publications_downloads . '.pn_homepage');

$publications_editorials = $prefix . '_editorials';
$pntable['publications_editorials'] = $publications_editorials;
$pntable['publications_editorials_column'] = array ('downloadid'         => $publications_editorials . '.pn_id',
                                                 'adminid'            => $publications_editorials . '.pn_adminid',
                                                 'editorialtimestamp' => $publications_editorials . '.pn_timestamp',
                                                 'editorialtext'      => $publications_editorials . '.pn_text',
                                                 'editorialtitle'     => $publications_editorials . '.pn_title');

$publications_modrequest = $prefix . '_modrequest';
$pntable['publications_modrequest'] = $publications_modrequest;
$pntable['publications_modrequest_column'] = array ('requestid'       => $publications_modrequest . '.pn_requestid',
                                                 'lid'             => $publications_modrequest . '.pn_lid',
                                                 'cid'             => $publications_modrequest . '.pn_cid',
                                                 'sid'             => $publications_modrequest . '.pn_sid',
                                                 'title'           => $publications_modrequest . '.pn_title',
                                                 'url'             => $publications_modrequest . '.pn_url',
                                                 'description'     => $publications_modrequest . '.pn_description',
                                                 'modifysubmitter' => $publications_modrequest . '.pn_modifysubmitter',
                                                 'brokendownload'  => $publications_modrequest . '.pn_brokendownload',
                                                 'name'            => $publications_modrequest . '.pn_name',
                                                 'email'           => $publications_modrequest . '.pn_email',
                                                 'filesize'        => $publications_modrequest . '.pn_filesize',
                                                 'version'         => $publications_modrequest . '.pn_version',
                                                 'homepage'        => $publications_modrequest . '.pn_homepage');

$publications_newdownload = $prefix . '_newdownload';
$pntable['publications_newdownload'] = $publications_newdownload;
$pntable['publications_newdownload_column'] = array ('lid'         => $publications_newdownload . '.pn_lid',
                                                  'cid'         => $publications_newdownload . '.pn_cid',
                                                  'sid'         => $publications_newdownload . '.pn_sid',
                                                  'title'       => $publications_newdownload . '.pn_title',
                                                  'url'         => $publications_newdownload . '.pn_url',
                                                  'description' => $publications_newdownload . '.pn_description',
                                                  'name'        => $publications_newdownload . '.pn_name',
                                                  'email'       => $publications_newdownload . '.pn_email',
                                                  'submitter'   => $publications_newdownload . '.pn_submitter',
                                                  'filesize'    => $publications_newdownload . '.pn_filesize',
                                                  'version'     => $publications_newdownload . '.pn_version',
                                                  'homepage'    => $publications_newdownload . '.pn_homepage');

$publications_subcategories = $prefix . '_downloads_subcategories';
$pntable['publications_subcategories'] = $publications_subcategories;
$pntable['publications_subcategories_column'] = array ('sid'    => $publications_subcategories . '.pn_sid',
                                                    'cid'       => $publications_subcategories . '.pn_cid',
                                                    'title'     => $publications_subcategories . '.pn_title');

$publications_votedata = $prefix . '_votedata';
$pntable['publications_votedata'] = $publications_votedata;
$pntable['publications_votedata_column'] = array ('ratingdbid'   => $publications_votedata . '.pn_id',
                                               'ratinglid'       => $publications_votedata . '.pn_lid',
                                               'ratinguser'      => $publications_votedata . '.pn_user',
                                               'rating'          => $publications_votedata . '.pn_rating',
                                               'ratinghostname'  => $publications_votedata . '.pn_hostname',
                                               'ratingcomments'  => $publications_votedata . '.pn_comments',
                                               'ratingtimestamp' => $publications_votedata . '.pn_timestamp');






    // Return the table information
    return $pntable;
}

?>
