<?php // $Id: bk-modbooks.php,v 1.1.1.1 2004/05/06 03:54:10 dyksjare Exp $
// ----------------------------------------------------------------------
// BOOKS module
// Copyright (C) 2002 by Michael Schatz
// Written by Michael Schatz and Jason Levitt and Olivier Guillet
// Get the newest version at http://sourceforge.net/projects/pn-mod-books
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com
// ----------------------------------------------------------------------

if (!eregi("modules.php", $PHP_SELF)) { die ("You can't access this file directly..."); }

$ModName = $GLOBALS['name'];
modules_get_language();

/*--------------------------------------------------------------------------
 * function  ShowAMessage
 *--------------------------------------------------------------------------
 * purpose   show a (error) message on screen
 * input     $message : message to show
 * output    -
 * changes   2001-09-26 [MS] introduced
 *--------------------------------------------------------------------------*/
function ShowAMessage($message) {
    include("header.php");
    menu(1);
    echo "<br>";
    OpenTable();
    echo "<font class=\"pn-normal\"><center><b>$message</b><br><br>"._GOBACK."</font>";
    CloseTable();
    include("footer.php");
}

/*--------------------------------------------------------------------------
 * function  AddBook
 *--------------------------------------------------------------------------
 * purpose   add a book into the request-for-insert list
 * input     $title         : book title
 *           $author        : book author
 *           $isbn          : book isbn
 *           $cat           : book category
 *           $description   : book description
 *           $nname         : user name
 *           $email         : user email
 * output    -
 * changes   2001-09-26 [MS] done some error fixing, made this thing work
 *           2001-11-06 [MS]restricted to premium_user
 *--------------------------------------------------------------------------*/
function AddBook($title, $author, $isbn, $cat, $description, $nname, $email) {
    global  $pntable;

    if ($isbn=="") ShowAMessage(_BOOKNOISBN);   /* Check if isbn is given */
    /* check if book already exists */
    $result = mysql_query("select count(*) as count from $pntable[books_books] where isbn='$isbn'");
    $numrows = mysql_result($result,0,"count");
    if ($numrows > 0) {
        ShowAMessage(_BOOKALREADYEXT);         /* book already exists */
    } else {                        
      if ($title=="") ShowAMessage(_BOOKNOTITLE); /* Check if title is given */
      if ($description=="") ShowAMessage(_BOOKNODESC); /* Check if description is given */

    $cat = explode("-", $cat);
    if ($cat[1]=="") $cat[1] = 0;

    if ($email == _NOEMAIL) {
       $email = "";
    }

    if ($nname == pnConfigGetVar('anonymous')) {
       $nname="";
    }

    if ($submitter == pnConfigGetVar('anonymous')) {
       $submitter="";
    } else {
       $submitter=pnUserGetVar('uname'); 
    }


    $title = stripslashes(FixQuotes($title));
    $isbn = stripslashes(FixQuotes($isbn));
    $author = stripslashes(FixQuotes($author));
    $description = stripslashes(FixQuotes($description));
    $nname = stripslashes(FixQuotes($nname));
    $email = stripslashes(FixQuotes($email));

    mysql_query("INSERT INTO $pntable[books_newbook] (bkid, cid, sid, title, author, isbn, description, name, email, submitter) VALUES (NULL, '$cat[0]', '$cat[1]', '$title', '$author', '$isbn', '$description', '$nname', '$email', '$submitter')");

    include("header.php");
    menu(1);
    echo "<br>";
    OpenTable();
    echo "<center><font class=\"pn-normal\"><b>"._BOOKRECEIVED1." $nname</b><br>".""._BOOKRECEIVED2."<br>";
    CloseTable();
    include("footer.php");
    }
}


/*--------------------------------------------------------------------------
 * function  AddBookForm
 *--------------------------------------------------------------------------
 * purpose   show form to enter information to add a book to request-for-insert-list
 * input     -
 * output    -
 * changes   2001-09-25 [MS] made this thing work
 *           2001-09-26 [MS] added pre-filled name & user field
 *                           put all into a table
 *           2001-10-29 [MS] using global functions, dropped useless vars
 *           2001-11-06 [MS] restricted to premium_user
 *--------------------------------------------------------------------------*/
function AddBookForm()
{
    global $user, $pntable;
    include("header.php");
    $mainlink = 1;
    menu(1);
    echo "<br>"; 
    OpenTable();

    $urlinsfunc=pnModGetVar('books','urlinsfunc');  

    if (!pnSecAuthAction(0, 'books::', '::', ACCESS_COMMENT)) {
    echo _BOOKSNOACCESS;
    CloseTable();
    include("footer.php");
    return;
    }
    
  echo "<center><font class=\"pn-title\">"._ADDABOOK."</font></center><br><br>";

        if (pnUserLoggedIn()) {
            $thisuser=pnUserGetVar('uname');
        } else {
            $thisuser=pnConfigGetVar('anonymous');
        }

        $emailval=pnUserGetVar('femail');

        // Show an explanatory note to users who are wondering why
        // their email address doesn't display
        if ($emailval == "") {
           $emailval= _NOEMAIL;
        }

        echo "<font class=\"pn-normal\"><b>"._INSTRUCTIONS.":</b><br>"
            ."<strong><big>&middot;</big></strong> "._BOOKSUBMITONCE."<br>"
            ."<strong><big>&middot;</big></strong> "._BOOKPOSTPENDING."<br>"
            ."<strong><big>&middot;</big></strong> "._BOOKSMUSTFILL."<br>"
            ."<strong><big>&middot;</big></strong> "._USERANDIP."<br></font>"
            ."<form method=\"post\" action=\"$urlinsfunc=add_book\">"
            ."<font class=\"pn-normal\">"
            ."<table border=\"0\" cellspacing=\"0\" cellpadding=\"4\">"
            ."<tr align=left><td class=\"pn-normal\">"
            .""._BOOKTITLE."</td><td class=\"pn-normal\"><input type=\"text\" name=\"title\" size=\"55\" maxlength=\"100\"></td></tr>"
            ."<tr align=left><td class=\"pn-normal\">"
            .""._BOOKAUTHOR."</td><td class=\"pn-normal\"><input type=\"text\" name=\"author\" size=\"55\" maxlength=\"100\" value=\"\"></td></tr>"
            ."<tr align=left><td class=\"pn-normal\">"
            .""._BOOKISBN."</td><td class=\"pn-normal\"><input type=\"text\" name=\"isbn\" size=\"55\" maxlength=\"100\" value=\"\"></td></tr>";
        $result=mysql_query("select cid, title from $pntable[books_categories] order by title");
        echo "<tr align=left><td class=\"pn-normal\">"
            .""._CATEGORY."</td><td class=\"pn-normal\"><select name=\"cat\">";
        while(list($cid, $title) = mysql_fetch_row($result)) {
            echo "<option value=\"$cid\">$title</option>";
            $result2=mysql_query("select sid, title from $pntable[books_subcategories] where cid=$cid order by title");
            while(list($sid, $stitle) = mysql_fetch_row($result2)) {
                echo "<option value=\"$cid-$sid\">$title / $stitle</option>";
            }
        }
        echo "</select></td></tr>"
            ."<tr align=left><td class=\"pn-normal\" colspan=\"2\">"
            .""._LDESCRIPTION."<br><textarea name=\"description\" cols=\"60\" rows=\"5\"></textarea></td></tr>"
            ."<tr align=left><td class=\"pn-normal\">";
        echo ""._YOURNAME."</td><td class=\"pn-normal\">&nbsp;&nbsp;<b>$thisuser</b><input type=\"hidden\" name=\"nname\" value=\"$thisuser\"></td></tr>"
            ."<tr align=left><td class=\"pn-normal\">"
            .""._YOUREMAIL."</td><td class=\"pn-normal\">&nbsp;&nbsp;<b>$emailval</b><input type=\"hidden\" name=\"email\" value=\"$emailval\"></td></tr>"
            ."<tr align=left valign=\"center\"><td class=\"pn-normal\" colspan=\"2\" valign=\"center\">"
            ."<input type=\"submit\" value=\""._ADDBOOK."\"> "._GOBACK."</td></tr>"
            ."</table></font></form>";
    CloseTable();
    include("footer.php");
}

function completevotefooter($bkid, $ttitle, $ratinguser) {
    global $pntable, $modset;

   $sn=pnConfigGetVar('sitename');

    echo "<font class=\"pn-normal\">"._THANKSTOTAKETIME." $sn. "._LETSDECIDE."</font><br><br><br>";
    echo "<center>";
    BookInfoMenu($bkid,$ttitle);
    echo "</center>";
    CloseTable();
}

function completevote($error) {

    $anonwaitdays=pnModGetVar('books','anonwaitdays');  
    if ($error == "none")         echo "<center><font class=\"pn-normal\"><b>"._VOTE1."</b></font></center>";
    if ($error == "anonflood")    echo "<center><font class=\"pn-error\"><b>"._VOTE2." $anonwaitdays "._VOTE8.".</b></font></center><br>";
    if ($error == "regflood")     echo "<center><font class=\"pn-error\"><b>"._VOTE3."<br>"._VOTE4."</b></font></center><br>";
    if ($error == "postervote")   echo "<center><font class=\"pn-error\"><b>"._VOTE5."<br>"._VOTE4."</b></font></center><br>";
    if ($error == "nullerror")    echo "<center><font class=\"pn-error\"><b>"._VOTE6."</b></font></center><br>";
}

/*--------------------------------------------------------------------------
 * function  AddRating
 *--------------------------------------------------------------------------
 * purpose   Add a book rating to db
 * input     $ratingbkid        book id to rate
 *           $ratinguser        rating user
 *           $rating            the ratin (1-10)
 *           $ratinghost_name   where from
 *           $ratingcomments    any comments
 * output    -
 * changes   2001-11-14 [MS] make this thing work
 *--------------------------------------------------------------------------*/
function AddRating($ratingbkid, $ratinguser, $rating, $ratinghost_name, $ratingcomments) {
    global  $pntable, $modset, $dbconn;

    $passtest = "yes";
    $anonwaitdays=pnModGetVar('books','anonwaitdays');   
    include("header.php");

    menu(1);
    echo "<br>";
    OpenTable();

           if(pnUserLoggedIn()) {
                  $ratinguser = pnUserGetVar('uname');
           } else  {
                  $ratinguser = "";
           }


    $results3 = mysql_query("SELECT title FROM $pntable[books_books] WHERE bkid=$ratingbkid");
    while(list($title)=mysql_fetch_row($results3)) 
        $ttitle = $title;
    /* Make sure only 1 anonymous from an IP in a single day. */
    $ip = getenv("REMOTE_HOST");
    if (empty($ip)) { $ip = getenv("REMOTE_ADDR"); }
    /* Check if Rating is Null */
    if ($rating=="--") {
        $error = "nullerror";
        completevote($error);
        $passtest = "no";
    }
    /* Check if book POSTER is voting (UNLESS Anonymous users allowed to post) */
    if (pnUserLoggedIn()) {
        $result=mysql_query("select submitter from $pntable[books_books] where bkid=$ratingbkid");
        while(list($ratinguserDB)=mysql_fetch_row($result)) {
            if ($ratinguserDB==$ratinguser) {
                $error = "postervote";
                completevote($error);
                $passtest = "no";
            }
        }
    }
    /* Check if REG user is trying to vote twice. */
    if (pnUserLoggedIn()) {
        $result=mysql_query("select ratinguser from $pntable[books_votedata] where ratingbkid=$ratingbkid");
        while(list($ratinguserDB)=mysql_fetch_row($result)) {
            if ($ratinguserDB==$ratinguser) {
                $error = "regflood";
                completevote($error);
                $passtest = "no";
            }
        }
    }


    /* Check if ANONYMOUS user is trying to vote more than once per day. */
    if ($ratinguser == "") {
        $yesterdaytimestamp = (time()-(86400 * $anonwaitdays));
        $ytsDB = Date("Y-m-d H:i:s", $yesterdaytimestamp);

$result=mysql_query("select * FROM $pntable[books_votedata] WHERE ratingbkid=$ratingbkid AND ratinguser='' AND ratinghostname = '$ip' AND (to_days(now()) - to_days(ratingtimestamp) < $anonwaitdays)");

        $anonvotecount = mysql_num_rows($result);

        if ($anonvotecount >= 1) {
            $error = "anonflood";
            completevote($error);
            $passtest = "no";
        }
    }

    /* Passed Tests */
    if ($passtest == "yes") {
        $comment = stripslashes(FixQuotes($comment));
        /* All is well.  Add to Line Item Rate to DB. */
        mysql_query("INSERT INTO $pntable[books_votedata] (ratingdbid, ratingbkid, ratinguser, rating, ratinghostname, ratingcomments, ratingtimestamp) VALUES (NULL,'$ratingbkid', '$ratinguser', '$rating', '$ip', '$ratingcomments', now())");

//All is well.  Calculate Score & Add to Summary (for quick retrieval & 
//sorting) to DB. 
//NOTE: If weight is modified, ALL links need to be refreshed with 
//new weight. 
//Running a SQL statement with your modded calc for ALL links will 
//accomplish this. 

        $voteresult = mysql_query("select rating, ratinguser, ratingcomments FROM $pntable[books_votedata] WHERE ratingbkid = $ratingbkid");

        $totalvotesDB = mysql_num_rows($voteresult);

 $retv=vote_func($voteresult,$totalvotesDB);
 $finalrating=$retv[0];
 $truecomments=$retv[3];

        mysql_query("UPDATE $pntable[books_books] SET bookratingsummary=$finalrating, totalvotes=$totalvotesDB, totalcomments=$truecomments, hits=hits+1 WHERE bkid = $ratingbkid");
        $error = "none";
        completevote($error);
    }
    completevotefooter($ratingbkid, $ttitle, $ratinguser);
    include("footer.php");
}

/*--------------------------------------------------------------------------
 * function  BrokenLink
 *--------------------------------------------------------------------------
 * purpose   show a form to enter information about a broken link
 * input     $bkid
 * output    -
 * changes   -
 *--------------------------------------------------------------------------*/
function BrokenLink($bkid) {
   
    if (pnUserLoggedIn()) {
        $ratinguser = pnUserGetVar('uname');
       } else {
        $ratinguser = pnConfigGetVar('anonymous');
          }

    $urlinsfunc=pnModGetVar('books','urlinsfunc');  
    include("header.php");
    menu(1);
    echo "<br>";
    OpenTable();

    if (!pnSecAuthAction(0, 'books::', '::', ACCESS_READ)) {
    echo _BOOKSNOACCESS;
    CloseTable();
    include("footer.php");
    return;
    }

    echo "<center><font class=\"pn-normal\"><b>"._REPORTBROKEN."</b></font><br><br><br>";
    echo "<form action=\"$urlinsfunc=broken_link_submit\" method=\"post\">";
    echo "<font class=\"pn-normal\">";
    echo "<input type=\"hidden\" name=\"bkid\" value=\"$bkid\">";
    echo "<input type=\"hidden\" name=\"modifysubmitter\" value=\"$ratinguser\">";
    echo ""._THANKSBROKEN."<br>"._SECURITYBROKEN."<br><br>";
    echo "<input type=\"submit\" value=\""._REPORTBROKEN."\"></font></form></center>";
    CloseTable();
    include("footer.php");

}

/*--------------------------------------------------------------------------
 * function  BrokenLinkSubmit
 *--------------------------------------------------------------------------
 * purpose   
 * input     $bkid
 *           $modifysubmitter
 * output    
 * changes   
 *--------------------------------------------------------------------------*/
function BrokenLinkSubmit($bkid, $modifysubmitter) {
    global $user, $modset, $pntable;

    if ($modifysubmitter == pnConfigGetVar('anonymous')) {
    $modifysubmitter="";
    }

    mysql_query("INSERT INTO $pntable[books_modrequest] (requestid, bkid, modifysubmitter, BrokenLink) VALUES (NULL, $bkid, '$modifysubmitter', 1)");
    include("header.php");
    menu(1);
    echo "<br>";
    OpenTable();
    echo "<br><center>"._THANKSFORINFO."<br><br>"._LOOKTOREQUEST."</center><br>";
    CloseTable();
    include("footer.php");
}

/*--------------------------------------------------------------------------
 * function  ModifyLinkRequest
 *--------------------------------------------------------------------------
 * purpose   Reuqest a modification of a link
 * input     $bkid   Book ID to modify
 * output    -
 * changes   -
 *--------------------------------------------------------------------------*/
function ModifyLinkRequest($bkid) {
    global $modset, $blockunregmodify, $pntable;

    include("header.php");
    menu(1);
    echo "<br>";
    OpenTable();

    $urlinsfunc=pnModGetVar('books','urlinsfunc');  

    if (!pnSecAuthAction(0, 'books::', '::', ACCESS_COMMENT)) {
    echo _BOOKSNOACCESS;
    CloseTable();
    include("footer.php");
    return;
    }

    if (pnUserLoggedIn()) {
        $ratinguser = pnUserGetVar('uname');
    } else {
        $ratinguser = pnConfigGetVar('anonymous');
    }

        $result = mysql_query("select cid, sid, title, author, description from $pntable[books_books] where bkid=$bkid");
        echo "<center><font class=\"pn-normal\"><b>"._REQUESTBOOKMOD."</b></font><br><font class=\"pn-normal\">";
        while(list($cid, $sid, $title, $author, $description) = mysql_fetch_row($result)) {
            $author = stripslashes($author);
            $title = stripslashes($title);
            $description = stripslashes($description);
            echo "<form action=\"$urlinsfunc=modify_link_submit\" method=\"post\">"
                .""._BOOKID.": <b>$bkid</b></center><br><br><br>"
                .""._BOOKTITLE.":<br><input type=\"text\" name=\"title\" value=\"$title\" size=\"50\" maxlength=\"100\"><br><br>"
                .""._BOOKAUTHOR.":<br><input type=\"text\" name=\"author\" value=\"$author\" size=\"50\" maxlength=\"100\"><br><br>"
                .""._DESCRIPTION.": <br><textarea name=\"description\" cols=\"60\" rows=\"10\">$description</textarea><br><br>";
            $result2=mysql_query("select cid, title from $pntable[books_categories] order by title");
            echo "<input type=\"hidden\" name=\"bkid\" value=\"$bkid\">"
                ."<input type=\"hidden\" name=\"modifysubmitter\" value=\"$ratinguser\">"
                .""._CATEGORY.": <select name=\"cat\">";
            while(list($ccid, $ctitle) = mysql_fetch_row($result2)) {
                $sel = "";
                if ($cid==$ccid AND $sid==0) {
                    $sel = "selected";
                }
                echo "<option value=\"$ccid\" $sel>$ctitle</option>";
                $result3=mysql_query("select sid, title from $pntable[books_subcategories] where cid=$ccid order by title");
                while(list($ssid, $stitle) = mysql_fetch_row($result3)) {
                    $sel = "";
                    if ($sid==$ssid) {
                        $sel = "selected";
                    }
                    echo "<option value=\"$ccid-$ssid\" $sel>$ctitle / $stitle</option>";
                }
            }
            echo "</select><br><br>"
                ."<input type=\"submit\" value=\""._SENDREQUEST."\"></form>";
        }
    CloseTable();
    include("footer.php");
}


function ModifyLinkSubmit($bkid, $cat, $title, $author, $description, $modifysubmitter) {
    global  $modset, $blockunregmodify, $pntable;
    $blocknow = 0;
    include("header.php");
    menu(1);
    echo "<br>";

    OpenTable();
    if ($blockunregmodify == 1 && $modifysubmitter == pnConfigGetVar('anonymous')) {
    echo "<center><font class=\"pn-normal\">"._ONLYREGUSERSMODIFY."</font></center>";
        $blocknow = 1;
    }
    if ($blocknow != 1) {
        $cat = explode("-", $cat);
        if ($cat[1]=="") {
            $cat[1] = 0;
        }
        $title = stripslashes(FixQuotes($title));
        $author = stripslashes(FixQuotes($author));
        $description = stripslashes(FixQuotes($description));
        mysql_query("INSERT INTO $pntable[books_modrequest] (requestid, bkid, cid, sid, title, author, description, modifysubmitter, BrokenLink) VALUES (NULL, $bkid, $cat[0], $cat[1], '$title', '$author', '$description', '$modifysubmitter', 0)");
        echo "<center><font class=\"pn-normal\">"._THANKSFORINFO."<br><br>"._LOOKTOREQUEST."</font></center>";
    }
    CloseTable();
    include("footer.php");
}

/*--------------------------------------------------------------------------
 * function  RateBook
 *--------------------------------------------------------------------------
 * purpose   show a menu / form for rating a book
 * input     $bkid      book id
 *           $ttitle    transfered title
 * output    -
 * changes   2001-11-14 [MS] made this thingy work ...
 *--------------------------------------------------------------------------*/

function RateBook($bkid, $ttitle) {
    global  $datetime, $modset;

    include("header.php");
    menu(1);
    echo "<br>";

    OpenTable();

    if (!pnSecAuthAction(0, 'books::', '::', ACCESS_COMMENT)) {
    echo _BOOKSNOACCESS;
    CloseTable();
    include("footer.php");
    return;
    }

    $urlinsfunc=pnModGetVar('books','urlinsfunc');  
    $transfertitle = ereg_replace ("_", " ", $ttitle);
    $displaytitle = $transfertitle;
    $ip = getenv("REMOTE_HOST");
    if (empty($ip)) { $ip = getenv("REMOTE_ADDR"); }
    echo "<font class=\"pn-normal\"><b>$displaytitle</b></font>"
        ."<ul>"
        ."<li><font class=\"pn-normal\">"._RATEBOOKNOTE1."</font>"
        ."<li><font class=\"pn-normal\">"._RATEBOOKNOTE2."</font>"
        ."<li><font class=\"pn-normal\">"._RATEBOOKNOTE3."</font>"
        ."<li><font class=\"pn-normal\">"._RATEBOOKNOTE5."</font>";
        echo "</ul>";

    if (pnUserLoggedIn()) {
        $name = pnUserGetVar('uname');
    } 
    else {
        $name = pnConfigGetVar('anonymous');
    }

        echo "<form method=\"post\" action=\"$urlinsfunc=add_rating\">"
        ."<table border=\"0\" cellpadding=\"1\" cellspacing=\"0\" width=\"100%\">"
        ."<tr><td width=\"25\" nowrap></td>"
        ."<tr><td width=\"25\" nowrap></td><td width=\"550\">"
        ."<input type=\"hidden\" name=\"ratingbkid\" value=\"$bkid\">"
        ."<input type=\"hidden\" name=\"ratinguser\" value=\"$name\">"
        ."<input type=\"hidden\" name=\"ratinghost_name\" value=\"$ip\">"
        ."<font class=\"pn-normal\">"._RATEBOOK."&nbsp;&nbsp;"
        ."<select name=\"rating\">"
        ."<option>--</option>"
        ."<option>10</option>"
        ."<option>9</option>"
        ."<option>8</option>"
        ."<option>7</option>"
        ."<option>6</option>"
        ."<option>5</option>"
        ."<option>4</option>"
        ."<option>3</option>"
        ."<option>2</option>"
        ."<option>1</option>"
        ."</select></font>"
        ."<font class=\"pn-normal\"><input type=\"submit\" value=\""._RATE."\"></font>"
        ."<br><br>";

        echo "<font class=\"pn-normal\"><b>"._SCOMMENTS.":</b></font><br><textarea wrap=\"virtual\" cols=\"50\" rows=\"10\" name=\"ratingcomments\"></textarea>"
            ."<br><br><br>"
            ."</font></td>";

    echo "</tr></table></form>";
    CloseTable();
    include("footer.php");
}

?>
