<?php // $Id: delete.php,v 1.1.1.1 2004/05/06 03:54:11 dyksjare Exp $
// ----------------------------------------------------------------------
// BOOKS module
// Copyright (C) 2002 by Michael Schatz
// Written by Michael Schatz and Jason Levitt and Olivier Guillet
// Get the newest version at http://sourceforge.net/projects/pn-mod-books
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com
// ----------------------------------------------------------------------
//
/************************************************************************/
/* Books Tables                                                         */
/************************************************************************/

include ("modules/books/bk-config.php");
$ModName = $GLOBALS['name'];

function index() {
        global $ModName, $bookprefix;
	include("header.php");
	OpenTable();
	echo "<center><h3>Welcome to PostNuke Books Database Deletion</h3></center><br>";
     	echo "This program will attempt to delete your existing books database.<br><br>The following tables will be deleted:"
       ."<ul>"
       ."<li>".$bookprefix."_books_categories</li>"
       ."<li>".$bookprefix."_books_subcategories</li>"
       ."<li>".$bookprefix."_books_editorials</li>"
       ."<li>".$bookprefix."_books_modrequest</li>"
       ."<li>".$bookprefix."_books_votedata</li>"
       ."<li>".$bookprefix."_books_newbook</li>"
       ."<li>".$bookprefix."_books_books</li>"
       ."</ul>"
       ."Clicking the button below will delete these tables from your Postnuke database."
       ."<br><br><input type=\"button\" value=\"Delete Tables\" onclick=\"location='modules.php?op=modload&amp;name=$ModName&amp;file=delete&amp;do=delete'\" />";
	 CloseTable();
	 include("footer.php");
}

function delete()
{
    global $pntable, $dbconn, $ModName, $bookprefix, $from;
    include("header.php");
    OpenTable();
    echo "<b>Deleting books tables from Postnuke database...</b><br><br>\n";

   $sql = "DROP TABLE $pntable[books_categories]";
   $dbconn->Execute($sql);

    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {

    // If no books table is found, they must have already been deleted.
    // So let's let the user exit normally.
       if (mysql_errno() == 1051) {
          echo "No books tables were found in your database. Nothing removed.";
          CloseTable();
          include("footer.php"); 
          return;
       }

          echo "Deletion failed at books module Table1";
          CloseTable();
          include("footer.php"); 
          return;
    }

    $sql = "DROP TABLE $pntable[books_editorials]";
   $dbconn->Execute($sql);

 // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
          echo "Deletion failed at books module Table2";
          CloseTable();
          include("footer.php"); 
        return;
    }

    $sql = "DROP TABLE $pntable[books_subcategories]";
   $dbconn->Execute($sql);

 // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
          echo "Deletion failed at books module Table3";
          CloseTable();
          include("footer.php"); 
        return;
    }

    $sql = "DROP TABLE $pntable[books_books]";
   $dbconn->Execute($sql);

 // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
          echo "Deletion failed at books module Table4";
          CloseTable();
          include("footer.php"); 
        return;
    }

    $sql = "DROP TABLE $pntable[books_modrequest]";
   $dbconn->Execute($sql);

 // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
          echo "Deletion failed at books module Table5";
          CloseTable();
          include("footer.php"); 
        return;
    }

    $sql = "DROP TABLE $pntable[books_newbook]";
   $dbconn->Execute($sql);

// Check for an error with the database code, and if so set an
// appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
          echo "Deletion failed at books module Table6";
          CloseTable();
          include("footer.php"); 
          return;
    }

    $sql = "DROP TABLE $pntable[books_votedata] ";
   $dbconn->Execute($sql);

// Check for an error with the database code, and if so set an
// appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
          echo "Deletion failed at books module Table7";
          CloseTable();
          include("footer.php"); 
          return;
    }
    
// remove any blocks associated with books
//    $modid = pnModGetIDFromName('books');
//    $sql = "DELETE FROM $blocks_table WHERE $blocks_column[mid] = $modid";
//    $dbconn->Execute($sql);

//Need more elaborate error reporting, if any, for block deletion 
//    if ($dbconn->ErrorNo() != 0) {
//        pnSessionSetVar('errormsg', 'books Blocks Clean-Up Failed');
//        return false;
//    }

    echo "<br><b>Congratulations!</b> You have successfully deleted the books tables from your Postnuke database.<br><br>\n";
    CloseTable();
    include("footer.php"); 
}

if (!pnSecAuthAction(0, 'books::', '::', ACCESS_ADMIN)) {
    include("header.php"); 
    echo _BOOKSNOAUTH;
    include("footer.php"); 
} else {

switch ($do)
{
    case "delete": 
         delete();
         break;
    default: 
         index();
         break;
}

}
?>
