<?php // $Id: upgrade.php,v 1.1.1.1 2004/05/06 03:54:13 dyksjare Exp $
// ----------------------------------------------------------------------
// BOOKS module
// Copyright (C) 2002 by Michael Schatz
// Written by Michael Schatz and Jason Levitt and Olivier Guillet
// Get the newest version at http://sourceforge.net/projects/pn-mod-books
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com
// ----------------------------------------------------------------------
//
//  #
//  # Tablestructure for books module
//  #
//  
//  CREATE TABLE nuke_books_books (
//     bkid int(11) DEFAULT '0' NOT NULL auto_increment,
//     cid int(11) DEFAULT '0' NOT NULL,
//     sid int(11) DEFAULT '0' NOT NULL,
//     isbn varchar(12) DEFAULT '0' NOT NULL,
//     title varchar(100) NOT NULL,
//     author varchar(100) NOT NULL,
//     description text NOT NULL,
//     date datetime,
//     order1 varchar(150),
//     order2 varchar(150),
//     order3 varchar(150),
//     order4 varchar(150),
//     order5 varchar(150),
//     order6 varchar(150),
//     cover varchar(100),
//     hits int(11) DEFAULT '0' NOT NULL,
//     submitter varchar(60) NOT NULL,
//     bookratingsummary double(6,4) DEFAULT '0.0000' NOT NULL,
//     totalvotes int(11) DEFAULT '0' NOT NULL,
//     totalcomments int(11) DEFAULT '0' NOT NULL,
//     language varchar(3),
//     PRIMARY KEY (bkid)
//  );
//  
//  CREATE TABLE nuke_books_categories (
//     cid int(11) DEFAULT '0' NOT NULL auto_increment,
//     title varchar(50) NOT NULL,
//     cdescription text NOT NULL,
//     language varchar(3),
//     PRIMARY KEY (cid)
//  );
//  
//  CREATE TABLE nuke_books_editorials (
//     bookid int(11) DEFAULT '0' NOT NULL,
//     adminid varchar(60) NOT NULL,
//     editorialtimestamp datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
//     editorialtext text NOT NULL,
//     editorialtitle varchar(100) NOT NULL,
//     language varchar(3),
//     PRIMARY KEY (bookid)
//  );
//  
//  CREATE TABLE nuke_books_modrequest (
//     requestid int(11) DEFAULT '0' NOT NULL auto_increment,
//     bkid int(11) DEFAULT '0' NOT NULL,
//     cid int(11) DEFAULT '0' NOT NULL,
//     sid int(11) DEFAULT '0' NOT NULL,
//     title varchar(100) NOT NULL,
//     author varchar(100) NOT NULL,
//     description text NOT NULL,
//     modifysubmitter varchar(60) NOT NULL,
//     brokenlink int(3) DEFAULT '0' NOT NULL,
//     PRIMARY KEY (requestid),
//     UNIQUE requestid (requestid)
//  );
//  
//  CREATE TABLE nuke_books_newbook (
//     bkid int(11) DEFAULT '0' NOT NULL auto_increment,
//     cid int(11) DEFAULT '0' NOT NULL,
//     sid int(11) DEFAULT '0' NOT NULL,
//     isbn varchar(12) DEFAULT '0' NOT NULL,
//     title varchar(100) NOT NULL,
//     author varchar(100) NOT NULL,
//     description text NOT NULL,
//     name varchar(100) NOT NULL,
//     email varchar(100) NOT NULL,
//     submitter varchar(60) NOT NULL,
//     PRIMARY KEY (bkid)
//  );
//  
//  CREATE TABLE nuke_books_subcategories (
//     sid int(11) DEFAULT '0' NOT NULL auto_increment,
//     cid int(11) DEFAULT '0' NOT NULL,
//     title varchar(50) NOT NULL,
//     language varchar(3),
//     PRIMARY KEY (sid)
//  );
//  
//  CREATE TABLE nuke_books_votedata (
//     ratingdbid int(11) DEFAULT '0' NOT NULL auto_increment,
//     ratingbkid int(11) DEFAULT '0' NOT NULL,
//     ratinguser varchar(60) NOT NULL,
//     rating int(11) DEFAULT '0' NOT NULL,
//     ratinghostname varchar(60) NOT NULL,
//     ratingcomments text NOT NULL,
//     ratingtimestamp datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
//     PRIMARY KEY (ratingdbid)
//  );
//  
//
/************************************************************************/
/* Books Tables                                                         */
/************************************************************************/

include ("modules/books/bk-config.php");
$ModName = $GLOBALS['name'];

function index(){
      global $ModName, $bookprefix;
	include("header.php");
	OpenTable();
	echo "<center><h3>Welcome to PostNuke Books Database Upgrade</h3></center><br>";
     	echo "This program will attempt to upgrade your existing books database to the latest version.<br><br>The following tables will be updated:"
       ."<ul>"
       ."<li>".$bookprefix."_books_categories</li>"
       ."<li>".$bookprefix."_books_subcategories</li>"
       ."<li>".$bookprefix."_books_editorials</li>"
       ."<li>".$bookprefix."_books_books</li>"
       ."</ul>"
       ."Clicking the button below will upgrade these tables in your database."
       ."<br><br><input type=\"button\" value=\"Upgrade Tables\" onclick=\"location='modules.php?op=modload&amp;name=$ModName&amp;file=upgrade&amp;do=upgrade'\" />";
	 CloseTable();
	 include("footer.php");
}

function upgrade()
{
    global $pntable, $dbconn, $ModName, $bookprefix, $from;
    include("header.php");
    OpenTable();
    echo "<b>Upgrading tables for Postnuke Books module...</b><br><br>\n";


// ---- books_categories ----
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_categories ADD language varchar(3)");

  // If errno == 1060, the variable already exists. This must be an upgraded
  // database
  if (mysql_errno() == 1060) {
    echo "It appears that your Books database has already been updated to the latest version. Exiting....";
    return;
       }

    if ($dbconn->ErrorNo() != 0) {
        echo "<br><br>Installation failed while creating table $pntable[books_categories]\n";
        echo "<br>(mySQL error ".mysql_errno(). ": ".mysql_error().")<br>\n";
        CloseTable();
        include("footer.php");
        exit();
    }
    echo "<br><br>Table $pntable[books_categories] updated\n";

// ---- books_subcategories ----
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_subcategories ADD language varchar(3)");
    
    if ($dbconn->ErrorNo() != 0) {
        echo "<br><br>Installation failed while creating table $pntable[books_subcategories]\n";
        echo "<br>(mySQL error ".mysql_errno(). ": ".mysql_error().")<br>\n";
        CloseTable();
        include("footer.php");
        exit();
    }
    echo "<br><br>Table $pntable[books_subcategories] updated\n";

// ---- books_editorials ----
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_editorials ADD language varchar(3)");

    if ($dbconn->ErrorNo() != 0) {
        echo "<br><br>Installation failed while creating table $pntable[books_editorials]\n";
        echo "<br>(mySQL error ".mysql_errno(). ": ".mysql_error().")<br>\n";
        CloseTable();
        include("footer.php");
        exit();
    }
    echo "<br><br>Table $pntable[books_editorials] updated\n";

// ---- books_books ----
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_books CHANGE order1 order1 varchar(150)");
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_books CHANGE order2 order2 varchar(150)");
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_books CHANGE order3 order3 varchar(150)");
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_books ADD order4 varchar(150) AFTER order3");
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_books ADD order5 varchar(150) AFTER order4");
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_books ADD order6 varchar(150) AFTER order5");
    $dbconn->Execute("ALTER TABLE ".$bookprefix."_books_books ADD language varchar(3)");

    if ($dbconn->ErrorNo() != 0) {
        echo "<br><br>Installation failed while creating table $pntable[books_books]\n";
        echo "<br>(mySQL error ".mysql_errno(). ": ".mysql_error().")<br>\n";
        CloseTable();
        include("footer.php");
        exit();
    }
    echo "<br><br>Table $pntable[books_books] updated\n";

    echo "<br><br><br><b>Congratulations!</b> You have successfully upgraded the tables for the Postnuke Books module.<br><br>\n";
    CloseTable();
    include("footer.php"); 
}

if (!pnSecAuthAction(0, 'books::', '::', ACCESS_ADMIN)) {
    include("header.php");
    echo _BOOKSNOAUTH;
    include("footer.php");
} else {

switch ($do)
{

    case "upgrade": 
         upgrade();
         break;
    default: index();
         break;
}
}
?>
