<?php
/***************************************************************************
 *                           page_header_admin.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: page_header_admin.php,v 1.1.1.1 2004/05/06 03:57:10 dyksjare Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

define('HEADER_INC', true);

//
// gzip_compression
//
$do_gzip_compress = FALSE;
/*
if ( $board_config['gzip_compress'] )
{
	$phpver = phpversion();

	if ( $phpver >= '4.0.4pl1' && strstr($HTTP_USER_AGENT,'compatible') )
	{
		if ( extension_loaded('zlib') )
		{
			ob_start('ob_gzhandler');
		}
	}
	else if ( $phpver > '4.0' )
	{
		if ( strstr($HTTP_SERVER_VARS['HTTP_ACCEPT_ENCODING'], 'gzip') )
		{
			if ( extension_loaded('zlib') )
			{
				$do_gzip_compress = TRUE;
				ob_start();
				ob_implicit_flush(0);

				header('Content-Encoding: gzip');
			}
		}
	}
}
*/
$template->set_filenames(array(
	'header' => 'admin/page_header.tpl')
);

//
// The following assigns all _common_ variables that may be used at any point
// in a template. Note that all URL's should be wrapped in append_sid, as
// should all S_x_ACTIONS for forms.
//
$template->assign_vars(array(
	'SITENAME' => $board_config['sitename'],
	'PAGE_TITLE' => $page_title,

	'L_ADMIN' => $lang['Admin'], 
	'L_INDEX' => sprintf($lang['Forum_Index'], $board_config['sitename']),
	'L_FAQ' => $lang['FAQ'],

	'U_INDEX' => append_sid('/index.'.$phpEx),

	'S_TIMEZONE' => sprintf($lang['All_times'], $lang[$board_config['board_timezone']]),
	'S_LOGIN_ACTION' => append_sid('/login.'.$phpEx),
	'S_JUMPBOX_ACTION' => append_sid('/viewforum.'.$phpEx),
	'S_CURRENT_TIME' => sprintf($lang['Current_time'], create_date($board_config['default_dateformat'], time(), $board_config['board_timezone'])), 
	'S_CONTENT_DIRECTION' => $lang['DIRECTION'], 
	'S_CONTENT_ENCODING' => $lang['ENCODING'], 
	'S_CONTENT_DIR_LEFT' => $lang['LEFT'], 
	'S_CONTENT_DIR_RIGHT' => $lang['RIGHT'], 

	'T_HEAD_STYLESHEET' => $theme_phpbb['head_stylesheet'],
	'T_BODY_BACKGROUND' => $theme_phpbb['body_background'],
	'T_BODY_BGCOLOR' => '#'.$theme_phpbb['body_bgcolor'],
	'T_BODY_TEXT' => '#'.$theme_phpbb['body_text'],
	'T_BODY_LINK' => '#'.$theme_phpbb['body_link'],
	'T_BODY_VLINK' => '#'.$theme_phpbb['body_vlink'],
	'T_BODY_ALINK' => '#'.$theme_phpbb['body_alink'],
	'T_BODY_HLINK' => '#'.$theme_phpbb['body_hlink'],
	'T_TR_COLOR1' => '#'.$theme_phpbb['tr_color1'],
	'T_TR_COLOR2' => '#'.$theme_phpbb['tr_color2'],
	'T_TR_COLOR3' => '#'.$theme_phpbb['tr_color3'],
	'T_TR_CLASS1' => $theme_phpbb['tr_class1'],
	'T_TR_CLASS2' => $theme_phpbb['tr_class2'],
	'T_TR_CLASS3' => $theme_phpbb['tr_class3'],
	'T_TH_COLOR1' => '#'.$theme_phpbb['th_color1'],
	'T_TH_COLOR2' => '#'.$theme_phpbb['th_color2'],
	'T_TH_COLOR3' => '#'.$theme_phpbb['th_color3'],
	'T_TH_CLASS1' => $theme_phpbb['th_class1'],
	'T_TH_CLASS2' => $theme_phpbb['th_class2'],
	'T_TH_CLASS3' => $theme_phpbb['th_class3'],
	'T_TD_COLOR1' => '#'.$theme_phpbb['td_color1'],
	'T_TD_COLOR2' => '#'.$theme_phpbb['td_color2'],
	'T_TD_COLOR3' => '#'.$theme_phpbb['td_color3'],
	'T_TD_CLASS1' => $theme_phpbb['td_class1'],
	'T_TD_CLASS2' => $theme_phpbb['td_class2'],
	'T_TD_CLASS3' => $theme_phpbb['td_class3'],
	'T_FONTFACE1' => $theme_phpbb['fontface1'],
	'T_FONTFACE2' => $theme_phpbb['fontface2'],
	'T_FONTFACE3' => $theme_phpbb['fontface3'],
	'T_FONTSIZE1' => $theme_phpbb['fontsize1'],
	'T_FONTSIZE2' => $theme_phpbb['fontsize2'],
	'T_FONTSIZE3' => $theme_phpbb['fontsize3'],
	'T_FONTCOLOR1' => '#'.$theme_phpbb['fontcolor1'],
	'T_FONTCOLOR2' => '#'.$theme_phpbb['fontcolor2'],
	'T_FONTCOLOR3' => '#'.$theme_phpbb['fontcolor3'],
	'T_SPAN_CLASS1' => $theme_phpbb['span_class1'],
	'T_SPAN_CLASS2' => $theme_phpbb['span_class2'],
	'T_SPAN_CLASS3' => $theme_phpbb['span_class3'])
);


$template->pparse('header');

?>