<?php
// File: $Id: admin.php,v 1.2 2004/05/17 19:19:12 dyksjare Exp $
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Chestnut ! - http://dev.pnconcept.com
// Purpose of file:  Group-AddOn administration
// ----------------------------------------------------------------------

if (!eregi('admin.php', $PHP_SELF)) {
	die ('Access Denied');
}

$ModName = basename( dirname( __FILE__ ) );
modules_get_language();
modules_get_manual();

/*
 * viewGroups - view groups
 *
 */
 
function display_groups($showgid, $min, $show)
{
	global $pntable, $ModName;

    include("header.php");
    GraphicAdmin();

    // Heading
    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"<B>"._GADMINTITLE."</B></FONT><BR><BR>\n";

    if (!pnSecAuthAction(0, 'pncgroups::', '::', ACCESS_EDIT)) {
        echo _GADMNOAUTH;
		CloseTable();
        include("footer.php");
        return;
    }

	echo "<a href=modules.php?op=modload&name=".$ModName."&file=index>"._GADMINDEXLINK."</a>\n";
	echo "<br><br>\n";
	echo "<a href=\"admin.php?module=".$ModName."&op=welcome\">"._PNCCHANGEWELCOME."</a>\n";
	echo "<br><br>\n";
	
    //Get database setup
	pnModDBInfoLoad('pncgroups');
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
        $pncgcolumn = &$pntable['pncgroups_column'];
        $grouptable = $pntable['groups'];
        $groupcolumn = &$pntable['groups_column'];
	$groupmship = $pntable['group_membership'];
	$groupmshipcolumn = &$pntable['group_membership_column'];
        $groupmship_pending = $pntable['pncgroups_pending'];
	$groupmship_pending_column = &$pntable['pncgroups_pending_column'];
        $usertable = $pntable['users'];
        $usercolumn = &$pntable['users_column'];

        //Create a list of groups by GID
        $groupList = array();

    // Get and display current groups
    $query = "SELECT	$groupcolumn[gid],
                    	$groupcolumn[name]
              FROM		$grouptable
              ORDER BY	$groupcolumn[name]";
    $result = $dbconn->Execute($query);
    if (!$result->EOF) {
        echo "<TABLE BORDER=0 CELLSPACING=1 width=90% bgcolor=".$bgcolor2.">\n"
			."<TR FONT=pn-title bgcolor=".$bgcolor3.">\n"
			."<TD width=50%><CENTER><b>"._GROUPNAME."</b></CENTER></TD>\n"
			."<td><CENTER><b>"._GUSERADMINFNC."</b></CENTER></td>\n"
			."</TR>\n"
			."<tr><td height=1></td></tr>\n";

		$myrowspansource = $result->PO_RecordCount();
        while(list($gid, $name) = $result->fields) {
			$result->MoveNext();
                        // Make a list of Group Names for later
                        $groupList[$gid] = $name;
            echo "<TR bgcolor=".$GLOBALS['bgcolor1'].">\n";
            if (pnSecAuthAction(0, 'Groups::', "$name::$gid", ACCESS_EDIT)) {
				echo "<TD align=center><b><A HREF=admin.php?module=".$ModName."&op=main&showgid=".pnVarPrepForDisplay($gid).">".pnVarPrepForDisplay($name)."</A></b></TD>\n";

				$pncgresult = $dbconn->Execute("SELECT $pncgcolumn[gid], $pncgcolumn[type], $pncgcolumn[description]
				 								FROM $pncgtable
												WHERE $pncgcolumn[gid]=".pnVarPrepForStore($gid));

				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				}
				if ($pncgresult->EOF) {
					echo "<td colspan=1 align=center><b><A HREF=admin.php?module=".$ModName."&op=refresh&gid=".pnVarPrepForDisplay($gid).">"._GADMREFRESH."</A></b></td>\n";
				} else {
					list($pncgid, $gtype, $description) = $pncgresult->fields;
					echo '<td align=center>';
					if (!$gtype==-1) {
						echo "[ <a href=\"admin.php?module=".$ModName."&op=modify&pncgid=".pnVarPrepForDisplay($pncgid)."\">"._GADMMODIFY."</a> ]\n";
					} else {
						echo "&nbsp;";
					}
					echo "</td>\n";
                }
                echo "</TR>\n";
            }
        }
        echo "</TABLE>\n";
    }

    CloseTable();

        echo "<hr>\n";

        // Show membership change requests waiting for aproval
        $query = "SELECT DISTINCT $groupmship_pending_column[gid],
		              	  $groupmship_pending_column[uid]
	          FROM		  $groupmship_pending";
        $result = $dbconn->Execute($query);
        OpenTable();
        echo "<tr><td align=center><font class=pn-title>"._GCHANGES."</font></td></tr>\n";
        if (!$result->EOF) {
            echo "<tr><td><table width=90% cellspacing=1 cellpadding=3 bgcolor=BLACK align=center>\n";
            echo "<tr bgcolor=#388CE0>";
            echo "<td align=center><font color=white><b>"._GUSERUNAME."</b></font></td>";
            echo "<td align=center><font color=white><b>"._GUSERREALNAME."</b></font></td>";
            echo "<td align=center><font color=white><b>"._GADDITION."</b></font></td>";
            echo "<td align=center><font color=white><b>"._GUSERADMINFNC."</b></font></td></tr>\n";
            while(list($gid, $uid) = $result->fields) {
                $result->MoveNext();
                
                // Lookup User Info from DB
                $uquery = "	SELECT 	$usercolumn[uname],
					$usercolumn[name]
				FROM $usertable
				WHERE 	$usercolumn[uid]='".pnVarPrepForStore($uid)."'";
                $uinforesult = $dbconn->Execute($uquery);
                if ($dbconn->ErrorNo() != 0) {
                    echo $dbconn->ErrorMsg();
                } else {
                    list($gpseudo, $gusername) = $uinforesult->fields;
                }    

                echo "<tr bgcolor=#F8F8F8>";
                echo "<td> <a target=\"_blank\" href=user.php?op=userinfo&uname=".pnVarPrepForDisplay($gpseudo)."><b>".pnVarPrepForDisplay($gpseudo)."</b></td>";
                echo "<td>".pnVarPrepForDisplay($gusername)."</td>";
                echo "<td>".pnVarPrepForDisplay($groupList[$gid])."</td>";
                echo "<td>[ <a href=\"admin.php?module=".$ModName."&op=mbrshp_grant&gid=".pnVarPrepForDisplay($gid)."&uid=".pnVarPrepForDisplay($uid)."\">"."Approve"."</a> ]<br>\n";
                echo "[ <a href=\"admin.php?module=".$ModName."&op=mbrshp_deny&gid=".pnVarPrepForDisplay($gid)."&uid=".pnVarPrepForDisplay($uid)."\">"."Deny"."</a> ]</td>";
                echo "</tr>\n";
            }
            echo "</table></td></tr>\n";
        } else {
            echo "<tr><td align=center>"._GNOCHANGES."</td></tr>\n";
        }
        CloseTable();
        echo "<br><br><hr>\n";



        // If a group is specified, display it
	if ($showgid) {
		OpenTable();
		// Get and display current groups
		$query = "SELECT	$groupcolumn[gid],
		                	$groupcolumn[name]
		          FROM		$grouptable
		          WHERE		$groupcolumn[gid]='".pnVarPrepForStore($showgid)."'";
		$result = $dbconn->Execute($query);
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				}
		if (!$result->EOF) {
			list($gid, $name) = $result->fields;
			$query2 = "	SELECT 	$pncgcolumn[gid],
								$pncgcolumn[type],
								$pncgcolumn[description],
								$pncgcolumn[gprefix],
								$pncgcolumn[gopen],
								$pncgcolumn[gnbuser],
								$pncgcolumn[gnbumax],
								$pncgcolumn[gmoderated],
								$pncgcolumn[link],
								$pncgcolumn[uidmaster]
						FROM $pncgtable
						WHERE $pncgcolumn[gid]='".pnVarPrepForStore($showgid)."'";
			$gresult = $dbconn->Execute($query2);
			if ($dbconn->ErrorNo() != 0) {
				echo $dbconn->ErrorMsg();
			}
			if (!$gresult->EOF) {
			
				list($pncgid, $gtype, $gdescription, $gprefix, $gopen, $gnbuser, $gnbumax, $gmoderated, $link, $gmaster) = $gresult->fields;
                                // Moderated Group?
                                $strmoderated = ($gmoderated)? _GYES: _GNO;

				$mshipresult = "SELECT count(*)
								FROM $groupmship
								WHERE $groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'";
				$membershipresult = $dbconn->Execute($mshipresult);
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				}
				if ($membershipresult->EOF) {
					$nbuser = 0;
				} else {
					list($nbuser) = $membershipresult->fields;
				}

				if ($gtype==-1) {
					$gtype = _GADMIN;
					$gopen_show = _GROUPCLOSE;
				} else {
					$gtype = _GADMADDED;
					if ($gopen==0) {
						$gopen_show = _GROUPCLOSE;
					} else {
						$gopen_show = _GROUPOPEN;
					}
				}
				echo "<br><br>\n";
				echo "<div align=center><font class=pn-title>"._GADMGROUP."".pnVarPrepForDisplay($name)."\n<br><br>\n";
				
                                $strMax = pnVarPrepForDisplay($gnbumax);
                                if ($strMax == 0) {
                                    $strMax = _GNA;
                                }

				echo "<TABLE BORDER=0 CELLSPACING=1 width=90% bgcolor=".$bgcolor2.">\n"
					."<TR bgcolor=".$GLOBALS['bgcolor2'].">"
					."<TD colspan=2></TD>\n"
					//."<TD><CENTER><b>".pnVarPrepForDisplay($gtype)."</b></CENTER></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD width=40%><CENTER><b>"._GDESCRIPTION."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".pnVarPrepForDisplay($gdescription)."</b></CENTER></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GROUPOPENCLOSE."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".pnVarPrepForDisplay($gopen_show)."</b></CENTER></TD>\n"
					."</TR>"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GNBUSERS."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".pnVarPrepForDisplay($nbuser)."</b></CENTER></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GNBUSERSMAX."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".$strMax."</b></CENTER></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GMODERATED."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".$strmoderated."</b></CENTER></TD>\n"
					."</TR>\n";

/****************************************/
/* Etape Chef de Groupe                 */
/****************************************/
/*
				$mastercol 		= &$pntable['users_column'];
				$mastertable 	= $pntable['users'];
				$masterquery 	= "	SELECT 	$mastercol[uname]
									FROM 	$mastertable
									WHERE 	$mastercol[uid]='".pnVarPrepForStore($gmaster)."'";				
				
				$masterresult = $dbconn->Execute($masterquery);
				
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				} else {
				
					list($mastername) = $masterresult->fields;
					if ($mastername!='Anonymous') {
					echo "<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
						."<TD><CENTER><b>"._GMASTER."</CENTER></b></TD>\n"
						."<TD><CENTER><b><a href=\"modules.php?op=modload&name=Messages&file=replypmsg&send=1&uname=".pnVarPrepForDisplay($mastername)."\">".pnVarPrepForDisplay($mastername)."</a></b></CENTER></TD>\n"
						."</TR>";
					}
				}
*/
/****************************************/
/* FIN Chef de Groupe                   */
/****************************************/

				echo "<TR FONT=pn-title bgcolor=".$GLOBALS['bgcolor2'].">\n"
					."<TD height=1 colspan=2></TD>\n"
					."</TR>\n"
					."<TR FONT=pn-title bgcolor=".$GLOBALS['bgcolor1'].">\n";
				if ($gtype != _GADMIN) {
					echo "<TD colspan=2>\n"
						."<CENTER>\n"
						."<br><b>\n"
						."[ <a href=\"admin.php?module=".$ModName."&op=modify&pncgid=".pnVarPrepForDisplay($gid)."\">"._GADMMODIFYUPC."</a> ]</b>\n"
						."-- > \n"
						."<a href=\"admin.php?module=".$ModName."&op=changetype&gid=".pnVarPrepForDisplay($gid)."&gtype=-1\">"._GADMTOCORE."</a>\n"
						."</CENTER></TD></TR>\n";
				} else {
					echo "<TD colspan=2>\n"
						."<CENTER>\n"
						."<br><b>\n"
						."[ "._GADMCORE." ]</b> -- > \n"
						."<a href=\"admin.php?module=".$ModName."&op=changetype&gid=".pnVarPrepForDisplay($gid)."&gtype=0\">"._GADMTOPUBLIC."</a>\n"
						."</CENTER></TD></TR>\n";
				}
				echo "</TABLE>\n";
				echo "<br><br>\n";
			}
		}

///////////////////////////////////////////////////
// Membres du groupe
///////////////////////////////////////////////////

		echo "<font class=pn-title><i>".pnVarPrepForDisplay($name)."</i> "._GUSERLIST."</font>\n";
		echo "<br><br>\n";
	
		echo "<table width=90% cellspacing=1 bgcolor=BLACK>\n";
		echo "<tr bgcolor=#388CE0>\n";
		echo "<td align=center><font color=white><b>"._GUSERSTATUS."</b></font></td>\n";
		echo "<td align=center><font color=white><b>"._GUSERAVATAR."</b></font></td>\n";
		echo "<td align=center><font color=white><b>"._GUSERUNAME."</b></font></td>\n";
		echo "<td align=center><font color=white><b>"._GUSERREALNAME."</b></font></td>\n";
		echo "<td align=center><font color=white><b>"._GUSERPM."</b></font></td>\n";
		echo "<td align=center><font color=white><b>"._GUSERURL."</b></font></td>\n";
		echo "<td align=center><font color=white><b>"._GUSERADMINFNC."</b></font></td>\n";
		echo "</tr>\n";

		$perpage = pnModGetVar('pncgroups', 'itemsperpage');
		if ($perpage.""=="") $perpage = 15;
	    if (!isset($min)) $min=0;
	    if (!isset($max)) $max=$min+$perpage;
	    if ($show!="") {
	        $perpage = $show;
	    } else {
	        $show = $perpage;
	    }

		$ucount = $dbconn->Execute("SELECT count(*)
									FROM $groupmship
									WHERE $groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'");
		list($numreg) = $ucount->fields;

			
		$query = "	SELECT $groupmshipcolumn[uid]
					FROM $groupmship
					WHERE $groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'";
		//$mlistresult = $dbconn->Execute($query);
		$mlistresult = $dbconn->SelectLimit($query, $perpage, $min);
		
		if ($dbconn->ErrorNo() != 0) {
			echo $dbconn->ErrorMsg();
		} else {
			while(list($guid) = $mlistresult->fields) {
				$mlistresult->MoveNext();
				$uquery = "	SELECT 	$usercolumn[uname],
									$usercolumn[name],
									$usercolumn[user_avatar],
									$usercolumn[url]
							FROM $usertable
							WHERE 	$usercolumn[uid]='".pnVarPrepForStore($guid)."'";
				$uinforesult = $dbconn->Execute($uquery);
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				} else {
					list($gpseudo, $gusername, $gavatar, $gurl) = $uinforesult->fields;
					$activetime = time() - (pnConfigGetVar('secinactivemins') * 60);
					$sessioninfocolumn = &$pntable['session_info_column'];
					$sessioninfotable = $pntable['session_info'];
					$onlinesess = $dbconn->Execute("SELECT DISTINCT $sessioninfocolumn[uid]
													FROM $sessioninfotable
													WHERE $sessioninfocolumn[uid] = $guid
													AND $sessioninfocolumn[lastused] > $activetime");
					if ($dbconn->ErrorNo() != 0) {
						echo $dbconn->ErrorMsg();
					}
					list($online) = $onlinesess->fields;
				    if ($online > ''){
					    $check = "<font color=red><b><img src=\"modules/".$ModName."/images/online.gif\" align=absmiddle border=0 alt=\"Online\"></b></font>\n";
				    } else {
						$check = "<font color=black><img src=\"modules/".$ModName."/images/offline.gif\" align=absmiddle border=0 alt=\"Offline\"></font>\n";
					}
					
					echo "<tr bgcolor=#F8F8F8>\n";
					echo "<td align=center>".$check."</td>\n";
					if ($gavatar=='blank.gif' OR $gavatar=='') {
						echo "<td align=center><img src=modules/".$ModName."/images/noav.gif alt=\""._GUSERNOAVATAR."\" border=0></td>\n";
					} else {
						echo "<td align=center><img src=images/avatar/".pnVarPrepForDisplay($gavatar)." alt=".pnVarPrepForDisplay($gavatar)." border=0></td>\n";
					}
					echo "<td align=center><b><a href=user.php?op=userinfo&uname=".pnVarPrepForDisplay($gpseudo).">".pnVarPrepForDisplay($gpseudo)."</a></b></td>\n";
					echo "<td align=center><b>".pnVarPrepForDisplay($gusername)."</b></td>\n";
					echo "<td align=center>\n"
						."<a href=\"modules.php?op=modload&name=Messages&file=replypmsg&send=1&uname=".pnVarPrepForDisplay($gpseudo)."\"><img src=\"modules/".$ModName."/images/mail.gif\" alt=\""._GUSERSENDPM."\" border=0></a></td>\n";
					if ($gurl) {
						if (!eregi("^http://[\-\.0-9a-z]+",$gurl)) {
				        	$gurl = "http://".$gurl;
		                }
						echo "<td align=center><a href=\"".pnVarPrepForDisplay($gurl)."\" target=\"_blank\">\n"
							."<img src=\"modules/".$ModName."/images/url.gif\" alt=\""._GUSERURLVISIT."\" border=0>\n"
							."</a></td>\n";
					} else {
						echo "<td>&nbsp;</td>\n";
					}
					echo "<td align=center>\n"
						."[ <a href=\"admin.php?module=".$ModName."&op=uremove&gid=".pnVarPrepForDisplay($gid)."&guid=".pnVarPrepForDisplay($guid)."\">"._GUSERADMREMOVE."</a> ]</td>\n";
					echo "</tr>\n";
	
				}
			}
		}
		echo "</table>\n";
	
		echo "<center>\n";
		$modurl = "admin.php?module=".$ModName."&file=index&op=main&showgid=".$showgid; //Shorten url text
		$regpagesint = ($numreg / $perpage);
		$regpageremainder = ($numreg % $perpage);
		if ($regpageremainder != 0) {
		    $regpages = ceil($regpagesint);
		    if ($numreg < $perpage) {
		        $regpageremainder = 0;
		    }
		} else {
		    $regpages = $regpagesint;
		}
		if ($regpages > 1) {
		    echo "<br><br>\n";
		    $prev=$min-$perpage;
			echo "<table border=\"0\">\n";
		    if ($prev>=0) {
		 		echo "<td align=\"center\" valign=\"bottom\"><a class=\"pn-normal\" href=\"".pnVarPrepForDisplay($modurl)."&amp;min=".pnVarPrepForDisplay($prev)."&amp;show=".pnVarPrepForDisplay($show)."\">\n"
					."<img src=\"modules/".$ModName."/images/left.gif\" border=\"0\" width=\"14\" height=\"11\"></a>&nbsp;&nbsp;&nbsp;</td>\n";
		    } else {
				echo "<td align=\"center\" valign=\"bottom\"><img src=\"modules/".$ModName."/images/left-no.gif\" border=\"0\" width=\"14\" height=\"11\">&nbsp;&nbsp;&nbsp;</td>\n";
			}
		    $counter = 1;
		    $currentpage = ($max / $perpage);
			echo "<td align=\"center\" valign=\"top\">\n";
		    while ($counter<=$regpages ) {
		        $cpage = $counter;
		        $mintemp = ($perpage * $counter) - $perpage;
		        if ($counter == $currentpage) {
		            echo "<font class=\"pn-normal\">".(int)$counter."</font>&nbsp\n";
		        } else {
		            //echo "<a class=\"pn-normal\" href=\"$modurl&amp;cid=$cid&amp;min=$mintemp&amp;show=$show\">".(int)$counter."</a> \n";
					echo "<a class=\"pn-title\" href=\"".pnVarPrepForDisplay($modurl)."&amp;min=".pnVarPrepForDisplay($mintemp)."&amp;show=".pnVarPrepForDisplay($show)."\">".(int)$counter."</a>&nbsp;&nbsp;\n";
		        }
		        $counter++;
		    }
			echo "</td>";
		    $next=$min+$perpage;
		    if ($currentpage < $regpages) {
		 		echo "<td align=\"center\" valign=\"bottom\">&nbsp;<a class=\"pn-normal\" href=\"".pnVarPrepForDisplay($modurl)."&amp;min=".pnVarPrepForDisplay($max)."&amp;show=".pnVarPrepForDisplay($show)."\">\n"
					."<img src=\"modules/".$ModName."/images/right.gif\" border=\"0\" width=\"14\" height=\"11\"></a></td>\n";
		    } else {
				echo "<td align=\"center\" valign=\"bottom\">&nbsp;<img src=\"modules/".$ModName."/images/right-no.gif\" border=\"0\" width=\"14\" height=\"11\"></td>\n";
		    }
			echo "</table>\n";
		}
		echo "<br><br>\n";
		CloseTable();

///////////////////////////////////////////////////
// Fin
///////////////////////////////////////////////////
	}

    include("footer.php");
}

function pncgroups_refresh_groups($gid) {
	global $ModName;
    //Get database setup
	pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];
    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];

    $query = "SELECT	$groupcolumn[gid]
              FROM		$grouptable
              WHERE		$groupcolumn[gid]='".pnVarPrepForStore($gid)."'";
    $result = $dbconn->Execute($query);
	list($gid) = $result->fields;
	$result->Close;
	
	$query = "INSERT INTO $pncgtable ($pncgcolumn[gid], $pncgcolumn[type]) VALUES (".pnVarPrepForStore($gid).", '-1')";
	$dbconn->Execute($query);
	if ($dbconn->ErrorNo() != 0) {
		echo $dbconn->ErrorMsg();
	} else {
		pnredirect('admin.php?module=pncgroups&op=main');
	}
}

function pncgroups_modify($pncgid)
{
	global $pntable, $ModName;

    include("header.php");
    GraphicAdmin();

    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"<B>"._GADMINTITLE."</B></FONT><BR><BR>";

    if (!pnSecAuthAction(0, 'Groups::', '::', ACCESS_EDIT)) {
        echo _GROUPSNOAUTH;
        include 'footer.php';
        return;
    }

    //Get database setup
	pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];
    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];

	if ($pncgid) {
		// Get and display current groups
		$query = "SELECT	$groupcolumn[gid],
		                	$groupcolumn[name]
		          FROM		$grouptable
		          WHERE		$groupcolumn[gid]='".pnVarPrepForStore($pncgid)."'";
		$result = $dbconn->Execute($query);
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				}
		if (!$result->EOF) {
			list($gid, $name) = $result->fields;
			$query2 = "	SELECT 	$pncgcolumn[gid],
								$pncgcolumn[type],
								$pncgcolumn[description],
								$pncgcolumn[gprefix],
								$pncgcolumn[gopen],
								$pncgcolumn[gmoderated],
								$pncgcolumn[gnbuser],
								$pncgcolumn[gnbumax],
								$pncgcolumn[link],
								$pncgcolumn[uidmaster]
						FROM $pncgtable
						WHERE $pncgcolumn[gid]='".pnVarPrepForStore($pncgid)."'";
			$gresult = $dbconn->Execute($query2);
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				}
			if (!$gresult->EOF) {
			
				list($pncgid, $gtype, $gdescription, $gprefix, $gopen, $gmoderated, $gnbuser, $gnbumax, $link, $gmaster) = $gresult->fields;
				if ($gtype==-1) {
					$gtype = _GADMIN;
					$gopen = _GROUPCLOSE;
				} else {
					$gtype = _GADMADDED;
					if ($gopen==0) {
						$gopen_show = _GROUPCLOSE;
					} else {
						$gopen_show = _GROUPOPEN;
					}
				}
				echo "<br><br>\n";
				echo "<div align=center><font class=pn-title>"._GADMGROUP."".pnVarPrepForDisplay($name)."<br><br>\n";

                                // Setup Display Variables... Membership limit of 0 is unlimited
                                $strlimited = "yes";
                                $strrestricted = "no";
                                $strmaxusers = pnVarPrepForDisplay($gnbumax);
                                $restrictedCheck = "checked";
                                $limitDisabled = "";
                                $moderatedCheck = "";
                                if ($gmoderated) {
                                    $strrestricted = "yes";
                                    $moderatedCheck = "checked";
                                }
                                if ($gnbumax == 0) {
                                    $restrictedCheck = "";
                                    $strlimited = "no";
                                    $strmaxusers = _GNA;
                                    $limitDisabled = "disabled";
                                }
                                
				echo "<form action=admin.php method=get>\n";				
				echo "<TABLE BORDER=0 CELLSPACING=1 width=90% bgcolor=".$GLOBALS['bgcolor2'].">\n"
					."<TR bgcolor=".$GLOBALS['bgcolor2'].">\n"
					."<TD colspan=3></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD width=25%><CENTER><b>"._GDESCRIPTION."</CENTER></b></TD>\n"
					."<TD width=25%><CENTER><b>".pnVarPrepForDisplay($gdescription)."</b></CENTER></TD>\n"
					."<TD><center><textarea wrap=\"virtual\" cols=\"35\" rows=\"5\" name=\"add_gdescription\"  value=\"".pnVarPrepForDisplay($gdescription)."\" class=\"pn-normal\">".pnVarPrepForDisplay($gdescription)."</textarea></td>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GROUPOPENCLOSE."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".pnVarPrepForDisplay($gopen_show)."</b></CENTER></TD>\n"
					."<TD><CENTER><select name=add_gopen>\n"
						."<option value=1>"._GAMDOPENGROUP."</option>\n"
						."<option value=0>"._GADMCLOSEGROUP."</option>\n"
						."</select></CENTER></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GNBLIMITED."</CENTER></b></TD>\n"
                                    ."<TD><CENTER><b>".$strlimited."</b></CENTER></TD>\n"
					."<TD><CENTER><input type=\"checkbox\" name=\"add_gulimited\" ".$restrictedCheck." onclick=\"javascript:add_gnbumax.disabled=!add_gulimited.checked;add_gnbumax.value='"._GNA."';\"></CENTER></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GNBUSERSMAX."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".$strmaxusers."</b></CENTER></TD>\n"
					."<TD><CENTER><input type=\"text\" name=\"add_gnbumax\" ".$limitDisabled." value=\"".$strmaxusers."\"></CENTER></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GNBRESTRICTED."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".$strrestricted."</b></CENTER></TD>\n"
					."<TD><CENTER><input type=\"checkbox\" name=\"add_grestricted\" ".$moderatedCheck."></CENTER></TD>\n"
					."</TR>\n";

/****************************************/
/* Etape Chef de Groupe                 */
/****************************************/
/*
				$mastercol 		= &$pntable['users_column'];
				$mastertable 	= $pntable['users'];
				$masterquery 	= "	SELECT 	$mastercol[uname]
									FROM 	$mastertable
									WHERE 	$mastercol[uid]='".pnVarPrepForStore($gmaster)."'";				
				$masterallquery	= "	SELECT 	$mastercol[uname], $mastercol[uid]
									FROM 	$mastertable
									ORDER BY $mastercol[uname]";				
				
				$masterresult = $dbconn->Execute($masterquery);
				$masterresultall = $dbconn->Execute($masterallquery);
				
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				} else {
				
					list($mastername) = $masterresult->fields;
					
					echo "<TR bgcolor=#F8F8F8>\n"
						."<TD><CENTER><b>"._GMASTER."</CENTER></b></TD>\n"
						."<TD><CENTER><b>".pnVarPrepForDisplay($mastername)."</b></CENTER></TD>\n"
						."<TD><CENTER><b><SELECT NAME=\"add_master\">\n";
						
					while(list($masternameall, $masteruidall) = $masterresultall->fields) {
						$masterresultall->MoveNext();
						
						if ($masternameall==$mastername) {
							$masterselect = "selected";
						} else {
							$masterselect = "";
						}
						
						echo "<OPTION VALUE=\"".pnVarPrepForDisplay($masteruidall)."\" ".pnVarPrepForDisplay($masterselect).">".pnVarPrepForDisplay($masternameall)."</OPTION>\n";
					
					}
					
					echo "</SELECT></b></CENTER></TD>\n"
						."</TR>\n";
				}
*/
/****************************************/
/* FIN Chef de Groupe                   */
/****************************************/




				echo "<TR FONT=pn-title bgcolor=".$GLOBALS['bgcolor2'].">\n"
					."<TD height=1 colspan=2></TD>\n"
					."<TR FONT=pn-title bgcolor=".$GLOBALS['bgcolor1'].">\n";

				echo "<input type=hidden name=pncgid value=\"".pnVarPrepForDisplay($pncgid)."\">\n";
				echo "<input type=hidden name=op value=modifynow>\n";
				echo "<input type=hidden name=module value=".$ModName.">\n";
				echo "<input type=hidden name=authid value=\"" . pnSecGenAuthKey() . "\">\n";
				echo "<TD colspan=3><CENTER><br><input type=submit value=\""._GADMSAVE."\"></CENTER></TD></TR>\n";

				echo "</FORM>\n";
				echo "</TABLE>\n";
				echo "<br><br>\n";
				echo "<a href=\"admin.php?module=".$ModName."&op=main\">"._GBACK."</a>\n";
			}
		}
	}
	CloseTable();

    include("footer.php");
}

function pncgroups_modifynow($pncgid, $add_gdescription, $add_gopen, $add_gnbumax, $add_gmoderated, $add_master='')
{

	global $ModName;
	if (!pnSecConfirmAuthKey()) {
	    include("header.php");
            echo _BADAUTHKEY;
            include("footer.php");
            exit;
        }
	
        // Make Input Sane
        if ($add_gnbumax == "") {
            $add_gnbumax = "0";
        }
        
        $add_gmoderated = ($add_gmoderated == "on")? 1: 0;

        
	pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];
	
	$add_gdescription = stripslashes($add_gdescription);
	
	$dbconn->Execute("UPDATE $pncgtable
                      SET $pncgcolumn[description]='".pnVarPrepForStore($add_gdescription)."',
                          $pncgcolumn[gopen]='".pnVarPrepForStore($add_gopen)."',
                          $pncgcolumn[gmoderated]='".pnVarPrepForStore($add_gmoderated)."',
                          $pncgcolumn[gnbumax]='".pnVarPrepForStore($add_gnbumax)."',
                          $pncgcolumn[uidmaster]='".pnVarPrepForStore($add_master)."'
                      WHERE $pncgcolumn[gid]='".pnVarPrepForStore($pncgid)."'");
	if($dbconn->ErrorNo() != 0) {
	    echo "DB Error: XModify - " . $dbconn->ErrorMsg();
    } else {
		$redirect = "admin.php?module=".$ModName."&op=main&showgid=".$pncgid;
		pnredirect($redirect);
	}

}

function pncgroups_uremove($guid, $gid)
{
	global $pntable, $ModName;

    include("header.php");

    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"<B>"._GADMINTITLE."</B></FONT><BR><BR>";

	if ($gid) {
		if ($guid) {
			echo "<br><br>";
			echo _GADMOUTUSER;
			echo pnVarPrepForDisplay($guid)." ?\n";
			echo "<br><br>";
			echo "[ <a href=\"admin.php?module=".$ModName."&op=uremovenow&gid=".pnVarPrepForDisplay($gid)."&guid=".pnVarPrepForDisplay($guid)."\">"._GYES."</a> ] - [ <A HREF=\"admin.php?module=".$ModName."&op=main\">"._GNO."</A> ]\n";
			echo "<br><br>\n";
		}
	}
	CloseTable();

    include("footer.php");
}

function pncgroups_uremovenow($guid, $gid)
{
	global $pntable, $ModName;

    include("header.php");

    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"<B>"._GADMINTITLE."</B></FONT><BR><BR>";

    //Get database setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$groupmship = $pntable['group_membership'];
	$groupmshipcolumn = &$pntable['group_membership_column'];
	
	if ($gid) {
		if ($guid) {
			$dbconn->Execute("	DELETE FROM $groupmship
								WHERE $groupmshipcolumn[gid]='".pnVarPrepForStore($gid)."'
								AND  $groupmshipcolumn[uid]='".pnVarPrepForStore($guid)."'");
			if ($dbconn->ErrorNo() != 0) {
				echo $dbconn->ErrorMsg();
			}
			echo "<br><br>\n";
			echo _GADMUSERISOFF;
			echo "<br><br>\n";
			echo "[ <A HREF=\"admin.php?module=".$ModName."&op=main\">"._GHOME."</A> ]\n";
			echo "<br><br>\n";
		}
	}
	CloseTable();

    include("footer.php");
}

function pncgroups_changetype($gid, $gtype)
{
	global $ModName;
	pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];
	
	if ($gid==2) {
		echo "DO NOT CHANGE THIS GROUP TO  PUBLIC !!!!!!!!!!!\n";
	} else {
		$dbconn->Execute("UPDATE $pncgtable
	                      SET $pncgcolumn[type]='".pnVarPrepForStore($gtype)."'
	                      WHERE $pncgcolumn[gid]='".pnVarPrepForStore($gid)."'");
		if($dbconn->ErrorNo() != 0) {
		    echo "DB Error: XModify - " . $dbconn->ErrorMsg();
	    } else {
			pnredirect('admin.php?module=pncgroups&op=main&showgid='.$gid);
		}
	}
}

function pncgroups_changewelcome()
{
	global $ModName;
	
    include("header.php");
    GraphicAdmin();

    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"<B>"._GADMINTITLE."</B></FONT><BR><BR>";

    if (!pnSecAuthAction(0, 'Groups::', '::', ACCESS_EDIT)) {
        echo _GROUPSNOAUTH;
        include 'footer.php';
        return;
    }
	
	$pncgadmmsg = pnModGetVar('pncgroups', 'pncgadmmsg');

	echo "<br><br>\n";
	echo "<div align=center><font class=pn-title>"._GADMGROUP."".pnVarPrepForDisplay($name)."<br><br>\n";

	echo "<form action=admin.php method=post>\n";				
	echo "<TABLE BORDER=0 CELLSPACING=0 width=90% bgcolor=".$GLOBALS['bgcolor2'].">\n"
		."<TR bgcolor=".$GLOBALS['bgcolor2'].">\n"
		."<TD width=25%><CENTER><b>"._WELCOMEMSGFNC."</CENTER></b></TD>\n"
		."</TR>\n"
		."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
		."<TD><CENTER><b><textarea cols=50 rows=10 name=\"newadminmsg\">".pnVarPrepForDisplay($pncgadmmsg)."</textarea>\n</TD>\n"
		."</TR>\n"
		."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
		."<TD colspan=3><CENTER><br><input type=submit value=\""._GADMSAVE."\"></CENTER></TD></TR>\n"
		."</TR>\n"
		."<input type=hidden name=op value=welcomeok>\n"
		."<input type=hidden name=module value=".$ModName.">\n"
		."<input type=hidden name=authid value=\"" . pnSecGenAuthKey() . "\">\n"
		."</FORM>\n"
		."</TABLE>\n"
		."<br><br>\n"
		."<a href=\"admin.php?module=".$ModName."&op=main\">"._GBACK."</a>\n";

	CloseTable();

    include("footer.php");
}

function pncgroups_changewelcomeok($newadminmsg)
{
	global $ModName;
	if (!pnSecConfirmAuthKey()) {
	    include("header.php");
        echo _BADAUTHKEY;
        include("footer.php");
        exit;
    }
	
	pnModSetVar('pncgroups', 'pncgadmmsg', $newadminmsg);
	
	pnredirect('admin.php?module='.$ModName.'&op=main');
}

/**
 * Approve a Pending Membership Change Request
 * 
 * @author Jared Dykstra
 * 
 * @param gid - Group ID
 * @param uid - User ID
 */
function pncgroups_mbrshp_approve($gid, $uid)
{
    // Proper Permissions?
    if (!pnSecAuthAction(0, 'Groups::', '::', ACCESS_EDIT)) {
        echo _GROUPSNOAUTH;
        include 'footer.php';
        return;
    }

    // Database info
    pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $groupmship_pending = $pntable['pncgroups_pending'];
    $groupmship_pending_column = &$pntable['pncgroups_pending_column'];
    $groupmship = $pntable['group_membership'];
    $groupmship_column = &$pntable['group_membership_column'];

    // Insert the request into the groups table
    $sql = "INSERT INTO $groupmship"
        ." ($groupmship_column[gid], $groupmship_column[uid]) "
        ." VALUES ('".pnVarPrepForStore($gid)."','".pnVarPrepForStore($uid)."')";
    $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
        echo $dbconn->ErrorMsg();
        return;
    } 

    // Drop the matching records from the pending table
    $sql = "DELETE FROM $groupmship_pending"
        ." WHERE $groupmship_pending_column[gid]='".pnVarPrepForStore($gid)."'"
        ." AND $groupmship_pending_column[uid]='".pnVarPrepForStore($uid)."'";
    $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
        echo $dbconn->ErrorMsg();
        return;
    } 
    // TODO: Why does pnredirect() not work here in *nix?
    pnredirect('admin.php?module=pncgroups&op=main');
    echo "<script language=\"Javascript\" type=\"text/javascript\">window.location.href='admin.php?module=pncgroups&op=main';</script>";
}


/**
 * Remove a Pending Membership Change Request
 * 
 * @author Jared Dykstra
 * 
 * @param gid - Group ID
 * @param uid - User ID
 */
function pncgroups_mbrshp_deny($gid, $uid)
{
    // Proper Permissions?
    if (!pnSecAuthAction(0, 'Groups::', '::', ACCESS_EDIT)) {
        echo _GROUPSNOAUTH;
        include 'footer.php';
        return;
    }

    // Database info
    pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $groupmship_pending = $pntable['pncgroups_pending'];
    $groupmship_pending_column = &$pntable['pncgroups_pending_column'];

    // Drop the matching records from the pending table
    $sql = "DELETE FROM $groupmship_pending"
        ." WHERE $groupmship_pending_column[gid]='".pnVarPrepForStore($gid)."'"
        ." AND $groupmship_pending_column[uid]='".pnVarPrepForStore($uid)."'";
    $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
        echo $dbconn->ErrorMsg();
        return;
    }
    // TODO: Why does pnredirect() not work here in *nix?
    pnredirect('admin.php?module=pncgroups&op=main');
    echo "<script language=\"Javascript\" type=\"text/javascript\">window.location.href='admin.php?module=pncgroups&op=main';</script>";
}


function pncgroups_admin_main($var)
{
	
	$op = pnVarCleanFromInput('op');

	if (!pnSecAuthAction(0, 'pncgroups::', '::', ACCESS_ADMIN)) {
		include("header.php");
	    echo _GROUPSNOAUTH;
		include("footer.php");
	} else {
	    switch($op) {

			case "refresh":
				$gid = pnVarCleanFromInput('gid');
				pncgroups_refresh_groups($gid);
				break;

			case "modify":
				$pncgid = pnVarCleanFromInput('pncgid');
				pncgroups_modify($pncgid);
				break;
		
			case "modifynow":
				list($pncgid,
                                     $add_gdescription,
                                     $add_gopen,
                                     $add_gnbumax,
                                     $add_gmoderated,
                                     $add_master)	=	pnVarCleanFromInput('pncgid',
                                                                                    'add_gdescription',
                                                                                    'add_gopen',
                                                                                    'add_gnbumax',
                                                                                    'add_grestricted',
                                                                                    'add_master');

				pncgroups_modifynow($pncgid, $add_gdescription, $add_gopen, $add_gnbumax, $add_gmoderated, $add_master);
				break;
			
			case "uremove":
				list(	$guid,
						$gid)	=	pnVarCleanFromInput('guid',
														'gid');
				pncgroups_uremove($guid, $gid);
				break;

			case "uremovenow":
				list(	$guid,
						$gid)	=	pnVarCleanFromInput('guid',
														'gid');
				pncgroups_uremovenow($guid, $gid);
				break;

			case "changetype":
				list(	$gid,
						$gtype)	=	pnVarCleanFromInput('gid',
														'gtype');
				pncgroups_changetype($gid, $gtype);
				break;

			case "welcome":
				pncgroups_changewelcome();
				break;

			case "welcomeok":
				$newadminmsg = pnVarCleanFromInput('newadminmsg');
				pncgroups_changewelcomeok($newadminmsg);
				break;

            case "mbrshp_grant":
                $gid = pnVarCleanFromInput('gid');
                $uid = pnVarCleanFromInput('uid');
                pncgroups_mbrshp_approve($gid, $uid);
                break;
                
            case "mbrshp_deny":
                $gid = pnVarCleanFromInput('gid');
                $uid = pnVarCleanFromInput('uid');
                pncgroups_mbrshp_deny($gid, $uid);
                break;

	        default:
				list(	$showgid,
						$min,
						$show)	=	pnVarCleanFromInput('showgid',
														'min',
														'show');
			    if (!isset($showgid)) {
					$showgid="";
				}
	   			if(!isset($min)) {
					$min = 0;
				}
			    if(!isset($show)) {
					$show = "";
				}
			   	display_groups($showgid, $min, $show);
	           	break;
		}
	}
}
?>
