<?php
// File: $Id: index.php,v 1.1.1.1 2004/05/06 03:58:10 dyksjare Exp $
// ----------------------------------------------------------------------
// POSTNUKE Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Chestnut !
// Purpose of file:  Group administration Add-On
// ----------------------------------------------------------------------

$ModName = basename( dirname( __FILE__ ) );
modules_get_language();

/*
 * viewGroups - view groups
 *
 */
 

function pncgroups_view_main($showgid, $min, $show)
{
	global $pntable, $ModName;

    include("header.php");
    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"><B>"._GMODTITLE."</B></FONT><BR><BR>";

    if (pnSecAuthAction(0, 'pncgroups::', '::', ACCESS_ADMIN)) {
        echo "<a href=admin.php?module=".$ModName."&op=main>"._GADMIN."</a>\n";
		$checkadmin = 1;
    }

	echo "<br><br>\n";
	$adminmsg = pnModGetVar('pncgroups','pncgadmmsg');
	echo pnVarPrepHTMLDisplay($adminmsg);
	echo "<br><br>\n";
	// End of Admin Message

    //Get database setup
	pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];
    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];
	$groupmship = $pntable['group_membership'];
	$groupmshipcolumn = &$pntable['group_membership_column'];


    // Get and display the viewable groups
    $query = "SELECT	$groupcolumn[gid],
                    	$groupcolumn[name]
              FROM		$grouptable
              ORDER BY	$groupcolumn[name]";
    $result = $dbconn->Execute($query);
    if (!$result->EOF) {
		echo "<TABLE BORDER=0 CELLSPACING=1 width=90% bgcolor=".$GLOBALS['bgcolor2'].">\n"
			."<TR FONT=pn-title bgcolor=".$GLOBALS['bgcolor2'].">\n"
			."<TD ALIGN=CENTER><B>"._GROUPNAME."</B></TD>\n"
			."</TR>\n"
			."<tr bgcolor=".$GLOBALS['bgcolor2']."><td></td></tr>\n";

		$myrowspansource = $result->PO_RecordCount();
        while(list($gid, $name) = $result->fields) {
			$result->MoveNext();
			$pncgresult = $dbconn->Execute("SELECT	$pncgcolumn[gid]
			 								FROM 	$pncgtable
											WHERE	$pncgcolumn[gid]=".pnVarPrepForStore($gid)."
											AND		$pncgcolumn[type] != '-1'");
			if ($dbconn->ErrorNo() != 0) {
				echo $dbconn->ErrorMsg();
			}
			if (!$pncgresult->EOF) {
				list($pncgid) = $pncgresult->fields;
				echo "<TR bgcolor=".$GLOBALS['bgcolor1'].">\n";
				echo "<TD align=center>\n"
					."<b><A HREF=modules.php?op=modload&name=".$ModName."&file=index&showgid=".pnVarPrepForDisplay($gid).">".pnVarPrepForDisplay($name)."</A></b>\n"
					."</TD>\n";
				echo "</TR>\n";
            }
        }
        echo "</TABLE>\n";

    }

    CloseTable();
	
	// If parameter ShowGroup
	if ($showgid) {
		
		// Get and display current groups
		$query = "SELECT	$groupcolumn[gid],
		                	$groupcolumn[name]
		          FROM		$grouptable
		          WHERE		$groupcolumn[gid]='".pnVarPrepForStore($showgid)."'";
		$result = $dbconn->Execute($query);
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				}
		if (!$result->EOF) {
			list($gid, $name) = $result->fields;
			$query2 = "	SELECT 	$pncgcolumn[gid],
								$pncgcolumn[type],
								$pncgcolumn[description],
								$pncgcolumn[gprefix],
								$pncgcolumn[gopen],
								$pncgcolumn[gnbuser],
								$pncgcolumn[gnbumax],
								$pncgcolumn[gmoderated],
								$pncgcolumn[link],
								$pncgcolumn[uidmaster]
						FROM	$pncgtable
						WHERE	$pncgcolumn[gid]='".pnVarPrepForStore($showgid)."'
						AND		$pncgcolumn[type]!='-1'";
			$gresult = $dbconn->Execute($query2);
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				}
			if (!$gresult->EOF) {
				list($pncgid, $gtype, $gdescription, $gprefix, $gopen, $gnbuser, $gnbumax, $gmoderated, $link, $gmaster) = $gresult->fields;

                                // Max Users Special Case
                                if ($gnbumax == 0) {
                                    $gnbmax = 1000000;
                                    $strmax = _GNA;
                                } else {
                                    $strmax = pnVarPrepForDisplay($gnbumax);
                                }
                                
                                // Moderated Group?
                                $strmoderated = ($gmoderated)? _GYES: _GNO;

				$mshipresult = "SELECT	count(*)
								FROM	$groupmship
								WHERE	$groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'";
				$membershipresult = $dbconn->Execute($mshipresult);
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				}
				if ($membershipresult->EOF) {
					$nbuser = 0;
				} else {
					list($nbuser) = $membershipresult->fields;
				}
				if ($nbuser >= $gnbumax) {
					$is_opento_user = 'Maximum Atteint';
				} else {
					$is_opento_user = 'place(s) libre(s)';
					$nburesult = $gnbumax - $nbuser;
				}

				if ($gtype!=-1) {
					if ($gopen==0) {
						$gopen_show = _GROUPCLOSE;
					} else {
						$gopen_show = _GROUPOPEN;
					}
				}

				OpenTable();
				echo "<br><br>\n";
				echo "<div align=center><font class=pn-title>"._GROUP." ".pnVarPrepForDisplay($name)."<br><br>\n";

                                if ($gopen && ($nbuser<$gnbumax || $gnbumax==0)) {
					$group_isopen = 1;
				} else {
					$group_isopen = 0;
				}
				
				echo "<TABLE BORDER=0 CELLSPACING=1 width=90% bgcolor=".$GLOBALS['bgcolor2'].">\n"
					."<TR bgcolor=".$GLOBALS['bgcolor2'].">\n"
					."<TD colspan=2></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD width=40%><CENTER><b>"._GDESCRIPTION."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".pnVarPrepForDisplay($gdescription)."</b></CENTER></TD>\n"
					."</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GROUPOPENCLOSE."</CENTER></b></TD>\n";
					
                                echo "<TD><CENTER><b>".pnVarPrepForDisplay($gopen_show)."</b></CENTER></TD>\n";
				
				echo "</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GNBUSERS."</CENTER></b></TD>\n";
				
                                echo "<TD><CENTER><b>".pnVarPrepForDisplay($nbuser)."</b></CENTER></TD>\n";
				
				echo "</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GNBUSERSMAX."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".$strmax."</b></CENTER></TD>\n"
					."</TR>\n";

				echo "</TR>\n"
					."<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
					."<TD><CENTER><b>"._GMODERATED."</CENTER></b></TD>\n"
					."<TD><CENTER><b>".$strmoderated."</b></CENTER></TD>\n"
					."</TR>\n";

				/****************************************/
				/* Etape Chef de Groupe                 */
				/****************************************/
/*
				$mastercol 		= &$pntable['users_column'];
				$mastertable 	= $pntable['users'];
				$masterquery 	= "	SELECT 	$mastercol[uname]
									FROM 	$mastertable
									WHERE 	$mastercol[uid]='".pnVarPrepForStore($gmaster)."'";				
				
				$masterresult = $dbconn->Execute($masterquery);
				
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				} else {
				
					list($mastername) = $masterresult->fields;
					if ($mastername!='Anonymous') {
					echo "<TR bgcolor=".$GLOBALS['bgcolor1'].">\n"
						."<TD><CENTER><b>"._GMASTER."</CENTER></b></TD>\n"
						."<TD><CENTER><b>\n"
						."<a href=modules.php?op=modload&name=Messages&file=replypmsg&send=1&uname=".pnVarPrepForDisplay($mastername).">".pnVarPrepForDisplay($mastername)."</a></b></CENTER>\n"
						."</TD>\n"
						."</TR>\n";
					}
				}
*/					
				/****************************************/
				/* FIN Chef de Groupe                   */
				/****************************************/

				echo "<TR FONT=pn-title bgcolor=".$GLOBALS['bgcolor2'].">\n"
					."<TD height=1 colspan=2></TD></TR>\n"
					."<TR FONT=pn-title bgcolor=".$GLOBALS['bgcolor1'].">\n";
				if ($gtype!="Administration") {
					if (pnUserLoggedIn()) {
						$check = pncgroups_issubscribed($pncgid);
						if ($check==0 && $group_isopen) {
							echo "<TD colspan=2><CENTER><br><b>[ ";
							echo "<a href=modules.php?op=modload&name=".$ModName."&file=index&req=subscribe&pncgid=".pnVarPrepForDisplay($pncgid)."&gname=".pnVarPrepForDisplay($name).">"._GSUBSCRIBE."</a>\n";
							echo " ]";
						} elseif ($check==0) {
							echo "<TD colspan=2><CENTER><br><b>[ ";
							echo "<FONT COLOR=RED>"._GFULLORCLOSE."</FONT>";
							echo " ]\n";
 						} else {
 							echo "<TD colspan=2><CENTER><br><b>[ ";
 							echo "<a href=modules.php?op=modload&name=".$ModName."&file=index&req=unsubscribe&pncgid=".pnVarPrepForDisplay($pncgid)."&gname=".pnVarPrepForDisplay($name);
 							echo ">"._GUNSUBSCRIBE."</a>\n";
 							echo " ]\n";
 						}
					} else {
						echo "<TD colspan=2><CENTER><br><b>[ ";
						echo "<a href=user.php>"._GMUSTBEREGGED."</a>\n";
						echo " ]\n";
					}
					echo "</b></CENTER></TD></TR>\n";
				} else {
					echo "<TD colspan=2><CENTER><br><b>"._GCORE."</b></CENTER></TD></TR>\n";
				}
				echo "</TABLE>\n";
				echo "<br><br>\n";

				///////////////////////////////////////////////////
				// Membres du groupe
				///////////////////////////////////////////////////

				//OpenTable();

				echo "<font class=pn-title>"._GUSERLIST."</font>\n";
				echo "<br><br>\n";
	
				echo "<table width=90% cellspacing=1 bgcolor=BLACK>\n";
				echo "<tr bgcolor=#388CE0>\n";
				echo "<td align=center><font color=white><b>"._GUSERSTATUS."</b></font></td>\n";
				echo "<td align=center><font color=white><b>"._GUSERAVATAR."</b></font></td>\n";
				echo "<td align=center><font color=white><b>"._GUSERUNAME."</b></font></td>\n";
				echo "<td align=center><font color=white><b>"._GUSERREALNAME."</b></font></td>\n";
				echo "<td align=center><font color=white><b>"._GUSERPM."</b></font></td>\n";
				echo "<td align=center><font color=white><b>"._GUSERURL."</b></font></td>\n";
				if ($checkadmin==1) {
					echo "<td align=center><font color=white><b>"._GUSERADMINFNC."</b></font></td>\n";
				}
				echo "</tr>\n";
				$perpage = pnModGetVar('pncgroups', 'itemsperpage');
				if ($perpage.""=="") $perpage = 10;
			    if (!isset($min)) $min=0;
			    if (!isset($max)) $max=$min+$perpage;
			    if ($show!="") {
			        $perpage = $show;
			    } else {
			        $show = $perpage;
			    }
				
				$ucount = $dbconn->Execute("SELECT count(*)
											FROM $groupmship
											WHERE $groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'");
				list($numreg) = $ucount->fields;
				
				
				$query = "	SELECT $groupmshipcolumn[uid]
							FROM $groupmship
							WHERE $groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'";
				
				$mlistresult = $dbconn->SelectLimit($query, $perpage, $min);
				
				//$mlistresult = $dbconn->Execute($query);
				if ($dbconn->ErrorNo() != 0) {
					echo $dbconn->ErrorMsg();
				} else {
					while(list($guid) = $mlistresult->fields) {
						$mlistresult->MoveNext();
						$usertable = $pntable['users'];
						$usercolumn = &$pntable['users_column'];
						$uquery = "	SELECT 	$usercolumn[uname],
											$usercolumn[name],
											$usercolumn[user_avatar],
											$usercolumn[url]
									FROM	$usertable
									WHERE 	$usercolumn[uid]='".pnVarPrepForStore($guid)."'";
						$uinforesult = $dbconn->Execute($uquery);
						if ($dbconn->ErrorNo() != 0) {
							echo $dbconn->ErrorMsg();
						} else {
							list($gpseudo, $gusername, $gavatar, $gurl) = $uinforesult->fields;
							$activetime = time() - (pnConfigGetVar('secinactivemins') * 60);
							$sessioninfocolumn = &$pntable['session_info_column'];
							$sessioninfotable = $pntable['session_info'];
							$onlinesess = $dbconn->Execute("SELECT DISTINCT	$sessioninfocolumn[uid]
															FROM			$sessioninfotable
															WHERE			$sessioninfocolumn[uid] = $guid
															AND				$sessioninfocolumn[lastused] > $activetime");
							if ($dbconn->ErrorNo() != 0) {
								echo $dbconn->ErrorMsg();
							}
							list($online) = $onlinesess->fields;
						    if ($online > ''){
							    $check = "<font color=red><b><img src=\"modules/".$ModName."/images/online.gif\" align=absmiddle border=0 alt=\"Online\"></b></font>\n";
						    } else {
								$check = "<font color=black><img src=\"modules/".$ModName."/images/offline.gif\" align=absmiddle border=0 alt=\"Offline\"></font>\n";
							}
							
							echo "<tr bgcolor=#F8F8F8>\n";
							echo "<td align=center>".$check."</td>\n";
							if ($gavatar=='blank.gif' OR $gavatar=='') {
								echo "<td align=center><img src=modules/".$ModName."/images/noav.gif alt=\""._GUSERNOAVATAR."\" border=0></td>\n";
							} else {
								echo "<td align=center><img src=images/avatar/".pnVarPrepForDisplay($gavatar)." alt=".pnVarPrepForDisplay($gavatar)." border=0></td>\n";
							}
							echo "<td align=center><b><a href=user.php?op=userinfo&uname=".pnVarPrepForDisplay($gpseudo).">".pnVarPrepForDisplay($gpseudo)."</a></b></td>\n";
							echo "<td align=center><b>".pnVarPrepForDisplay($gusername)."</b></td>\n";
							echo "<td align=center><a href=modules.php?op=modload&name=Messages&file=replypmsg&send=1&uname=".pnVarPrepForDisplay($gpseudo).">\n";
							echo "<img src=modules/".$ModName."/images/mail.gif alt=\""._GUSERSENDPM."\" border=0></a></td>\n";
							if ($gurl) {
								if (!eregi("^http://[\-\.0-9a-z]+",$gurl)) {
						        	$gurl = "http://".$gurl;
				                }
								echo "<td align=center><a href=".pnVarPrepForDisplay($gurl)." target=_blank>"
									."<img src=modules/".$ModName."/images/url.gif alt=\""._GUSERURLVISIT."\" border=0></a></td>\n";
							} else {
								echo "<td>&nbsp;</td>\n";
							}
							if ($checkadmin==1) {
								echo "<td align=center>[ <a href=admin.php?module=".$ModName."&op=uremove&gid=".pnVarPrepForDisplay($pncgid)."&guid=".pnVarPrepForDisplay($guid).">\n";
								echo _GUSERADMREMOVE."</a> ]</td>\n";
							}
							echo "</tr>\n";
			
						}
					}
				}
				echo "</table>\n";
			}

			echo "<center>\n";
    		/* Calculates how many pages exist. Which page one should be on, etc... */
			$modurl = "modules.php?op=modload&name=".$ModName."&file=index&req=main&showgid=".$showgid; //Shorten url text
    		$regpagesint = ($numreg / $perpage);
    		$regpageremainder = ($numreg % $perpage);
    		if ($regpageremainder != 0) {
    		    $regpages = ceil($regpagesint);
    		    if ($numreg < $perpage) {
    		        $regpageremainder = 0;
    		    }
    		} else {
    		    $regpages = $regpagesint;
    		}
    		/* Page Numbering */
    		if ($regpages > 1) {
    		    echo "<br><br>\n";
    		    $prev=$min-$perpage;
				echo "<table border=\"0\">\n";
    		    if ($prev>=0) {
    		 		echo "<td align=\"center\" valign=\"bottom\"><a class=\"pn-normal\" href=\"".pnVarPrepForDisplay($modurl)."&amp;min=".pnVarPrepForDisplay($prev)."&amp;show=".pnVarPrepForDisplay($show)."\">\n"
						."<img src=\"modules/".$ModName."/images/left.gif\" border=\"0\" width=\"14\" height=\"11\"></a>&nbsp;&nbsp;&nbsp;</td>\n";
    		    } else {
					echo "<td align=\"center\" valign=\"bottom\"><img src=\"modules/".$ModName."/images/left-no.gif\" border=\"0\" width=\"14\" height=\"11\">&nbsp;&nbsp;&nbsp;</td>\n";
				}
    		    $counter = 1;
    		    $currentpage = ($max / $perpage);
				echo "<td align=\"center\" valign=\"top\">\n";
    		    while ($counter<=$regpages ) {
    		        $cpage = $counter;
    		        $mintemp = ($perpage * $counter) - $perpage;
    		        if ($counter == $currentpage) {
    		            echo "<font class=\"pn-normal\">".(int)$counter."</font>&nbsp\n";
    		        } else {
    		            //echo "<a class=\"pn-normal\" href=\"$modurl&amp;cid=$cid&amp;min=$mintemp&amp;show=$show\">".(int)$counter."</a> \n";
						echo "<a class=\"pn-title\" href=\"".pnVarPrepForDisplay($modurl)."&amp;min=".pnVarPrepForDisplay($mintemp)."&amp;show=".pnVarPrepForDisplay($show)."\">".(int)$counter."</a>&nbsp;&nbsp;\n";
    		        }
    		        $counter++;
    		    }
				echo "</td>";
    		    $next=$min+$perpage;
    		    if ($currentpage < $regpages) {
    		 		echo "<td align=\"center\" valign=\"bottom\">&nbsp;<a class=\"pn-normal\" href=\"".pnVarPrepForDisplay($modurl)."&amp;min=".pnVarPrepForDisplay($max)."&amp;show=".pnVarPrepForDisplay($show)."\">\n"
						."<img src=\"modules/".$ModName."/images/right.gif\" border=\"0\" width=\"14\" height=\"11\"></a></td>\n";
    		    } else {
					echo "<td align=\"center\" valign=\"bottom\">&nbsp;<img src=\"modules/".$ModName."/images/right-no.gif\" border=\"0\" width=\"14\" height=\"11\"></td>\n";
    		    }
				echo "</table>\n";
    		}
			
			echo "<br><br>\n";
			CloseTable();
		}
	}

	///////////////////////////////////////////////////
	// Fin
	///////////////////////////////////////////////////

    include("footer.php");
}

function pncgroups_subscribe_groups($pncgid, $gname) {
	global $pntable, $ModName;
    include("header.php");

    // Heading
    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"><B>"._GMODTITLE."</B></FONT><BR><BR>";

    // Get database setup
	pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];
    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];
	$groupmship = $pntable['group_membership'];
	$groupmshipcolumn = &$pntable['group_membership_column'];
	
	// Vrication si le groupe est ouvert et s'il reste de la place.
	$query = "	SELECT 	$pncgcolumn[gid],
						$pncgcolumn[gopen],
						$pncgcolumn[gnbuser],
						$pncgcolumn[gnbumax],
						$pncgcolumn[gmoderated]
						FROM $pncgtable
						WHERE $pncgcolumn[gid]='".pnVarPrepForStore($pncgid)."'";	
	$gresult = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() != 0) {
		echo $dbconn->ErrorMsg();
	}
	list($pncgid, $gopen, $gnbuser, $gnbumax, $gmoderated) = $gresult->fields;
	if ($gopen==1) {
		$mshipresult = "SELECT count(*)
						FROM $groupmship
						WHERE $groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'";
		$membershipresult = $dbconn->Execute($mshipresult);
		if ($membershipresult->EOF) {
			$nbuser = 0;
		} else {
			list($nbuser) = $membershipresult->fields;
		}
		if ($nbuser<$gnbumax || $gnbumax==0) {
			// Vrification si le User est dj inscrit.
			$userid = pnUserGetVar('uid');
			$mshipuserresult = "SELECT	$groupmshipcolumn[gid],  $groupmshipcolumn[uid]
								FROM	$groupmship
								WHERE	$groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'
								AND		$groupmshipcolumn[uid]='".pnVarPrepForStore($userid)."'";
			$membershipuserresult = $dbconn->Execute($mshipuserresult);
			if ($membershipuserresult->EOF) {
                                if ($gmoderated) {
                                    echo "<br><br><i>"._GWARNMODERATED."</i><br><br>";
                                }
				echo "<br><br>\n";
				echo _GSUBSCRIBEASK."<b>".pnVarPrepForDisplay($gname)."</b>?\n";
				echo "<br><br>\n";
				echo "[ ";
				echo "<a href=modules.php?op=modload&name=".$ModName."&file=index&req=subscribenow&pncgid=".pnVarPrepForDisplay($pncgid).">\n";
				echo " "._GYES."</a> ] - [ ";
				echo "<A HREF=modules.php?op=modload&name=".$ModName."&file=index>\n";
				echo " "._GNO."</A> ]\n";
				echo "<br><br>\n";
			} else {
				echo "<br><br>\n";
				echo _GALREADYIN."".pnVarPrepForDisplay($gname)." ?\n";
				echo "<br><br>\n";
				echo "[ <A HREF=modules.php?op=modload&name=".$ModName."&file=index>"._GBACK."</A> ]\n";
				echo "<br><br>\n";
			}		
		} else {
			echo "<br><br>\n";
			echo _GISFULL;
			echo "<br><br>\n";
			echo "[ <A HREF=modules.php?op=modload&name=".$ModName."&file=index>"._GBACK."</A> ]\n";
			echo "<br><br>\n";
		}
	} else {
		echo "<br><br>\n";
		echo _GISCLOSENOW;
		echo "<br><br>\n";
		echo "[ <A HREF=modules.php?op=modload&name=".$ModName."&file=index>"._GBACK."</A> ]\n";
		echo "<br><br>\n";
	}
	CloseTable();
	include("footer.php");
}

function pncgroups_subscribenow($pncgid)
{
	global $pntable;

    include("header.php");

    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"><B>"._GMODTITLE."</B></FONT><BR><BR>";

    //Get database setup
	pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];
    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];
	$groupmship = $pntable['group_membership'];
	$grouppending = $pntable['pncgroups_pending'];
	$groupmshipcolumn = &$pntable['group_membership_column'];
        $groupmshipcolumn_pending = &$pntable['pncgroups_pending_column'];
	

        // Check to see if this group is open, not full, and moderated
	$query = "	SELECT 	$pncgcolumn[gid],
						$pncgcolumn[gopen],
						$pncgcolumn[gnbumax],
						$pncgcolumn[gmoderated]
						FROM $pncgtable
						WHERE $pncgcolumn[gid]='".pnVarPrepForStore($pncgid)."'";	
	$gresult = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() != 0) {
		echo $dbconn->ErrorMsg();
	}
	list($pncgid, $gopen, $gnbumax, $gmoderated) = $gresult->fields;

        if (!$gopen) {
            // Someone is trying to hack their way into a new group
            // TODO: Verify User Count
            return;
        }
        

	if ($pncgid) {
		//Inscription dans le groupe
		$userid = pnUserGetVar('uid');
		if ($userid) {

                    // If moderated, insert into the pending table
                    if (!$gmoderated) {
                        $table = $groupmship;
                        $gid = $groupmshipcolumn[gid];
                        $uid = $groupmshipcolumn[uid];
                    } else {
                        $table = $grouppending;
                        $gid = $groupmshipcolumn_pending[gid];
                        $uid = $groupmshipcolumn_pending[uid];
                    }
                    
                        // Insert
			$sql = "	INSERT INTO $table ($gid, $uid) "
                            ."VALUES ('".pnVarPrepForStore($pncgid)."', '".pnVarPrepForStore($userid)."')";

                        $dbconn->Execute($sql);
			if ($dbconn->ErrorNo() != 0) {
				echo $dbconn->ErrorMsg();
			}
                      
			$sql = "SELECT	$groupcolumn[gid],
			                	$groupcolumn[name]
			          FROM		$grouptable
			          WHERE		$groupcolumn[gid]='".pnVarPrepForStore($pncgid)."'";
			$result = $dbconn->Execute($sql);
			if ($dbconn->ErrorNo() != 0) {
				echo $dbconn->ErrorMsg();
			}		
			if (!$result->EOF) {
				echo "<br><br>\n";
                                if (!$gmoderated) {
                                    echo _GYOUARENOWIN;
                                } else {
                                    echo _GMBRSHPPENDING;
                                }
				echo "<br><br>\n";
				echo "[ <A HREF=index.php>"._GHOME."</A> ]\n";
				echo "<br><br>\n";
			}
		}
	}
	CloseTable();

    include("footer.php");
}

function pncgroups_unsubscribe_groups($pncgid, $gname) {
	global $pntable, $ModName;
    include("header.php");

    // Heading
    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"<B>Groupes-AddOn</B></FONT><BR><BR>";

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$groupmship = $pntable['group_membership'];
	$groupmshipcolumn = &$pntable['group_membership_column'];
	
	$check = pncgroups_issubscribed($pncgid);
	if ($check==1) {
		echo "<br><br>\n";
		echo _GUNSUBSCRIBEASK."".pnVarPrepForDisplay($gname)." ?\n";
		echo "<br><br>\n";
		echo "[ ";
		echo "<a href=modules.php?op=modload&name=".$ModName."&file=index&req=unsubscribenow&pncgid=".pnVarPrepForDisplay($pncgid).">\n";
		echo " "._GYES."</a> ] - [ ";
		echo "<A HREF=modules.php?op=modload&name=".$ModName."&file=index>\n";
		echo " "._GNO."</A> ]\n";
		echo "<br><br>\n";
	}
	CloseTable();
	include("footer.php");
}

function pncgroups_unsubscribenow($pncgid)
{
	global $pntable;

    include("header.php");

    OpenTable();
    echo "<CENTER><FONT SIZE=\"4\"<B>Groupe-AddOn</B></FONT><BR><BR>";

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$groupmship = $pntable['group_membership'];
	$groupmshipcolumn = &$pntable['group_membership_column'];
	
	if ($pncgid) {
		//Inscription dans le groupe
		$userid = pnUserGetVar('uid');
		if ($userid) {
			$dbconn->Execute("	DELETE FROM	$groupmship
								WHERE		$groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'
								AND			$groupmshipcolumn[uid]='".pnVarPrepForStore($userid)."'");
			if ($dbconn->ErrorNo() != 0) {
				echo $dbconn->ErrorMsg();
			}
			$check = pncgroups_issubscribed($pncgid);
			if ($check==0) {
				echo "<br><br>\n";
				echo _GYOUARENOWOUT;
				echo "<br><br>\n";
				echo "[ <A HREF=index.php>"._GHOME."</A> ]\n";
				echo "<br><br>\n";
			}
		}
	}
	CloseTable();

    include("footer.php");
}

function pncgroups_issubscribed($pncgid) {

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	$groupmship = $pntable['group_membership'];
	$groupmshipcolumn = &$pntable['group_membership_column'];

	$isuser = pnUserGetVar('uid');
	$isresult = $dbconn->Execute("	SELECT	$groupmshipcolumn[gid], $groupmshipcolumn[uid]
									FROM	$groupmship
									WHERE	$groupmshipcolumn[gid]='".pnVarPrepForStore($pncgid)."'
									AND		$groupmshipcolumn[uid]='".pnVarPrepForStore($isuser)."'");
	if (!$isresult->EOF) {
		$issub = 1;
	} else {
		$issub = 0;
	}
	
	return $issub;
}


$op = pnVarCleanFromInput('op');

if (!pnSecAuthAction(0, 'pncgroups::', '::', ACCESS_READ)) {
	include 'header.php';
    echo _GROUPSNOAUTH;
	include 'footer.php';
} else {
    switch($req) {

		case "subscribe":
			pncgroups_subscribe_groups($pncgid, $gname);
			break;
		
		case "subscribenow":
			pncgroups_subscribenow($pncgid);
			break;

		case "unsubscribe":
			pncgroups_unsubscribe_groups($pncgid, $gname);
			break;

		case "unsubscribenow":
			pncgroups_unsubscribenow($pncgid);
			break;
			
        case "main":
		    if (!isset($showgid)) $showgid='';
   			if(!isset($min)) {
				$min = 0;
			}
		    if(!isset($show)) {
				$show = '';
			}
		   	pncgroups_view_main($showgid, $min, $show);
           	break;

        default:
		    if (!isset($showgid)) $showgid='';
   			if(!isset($min)) {
				$min = 0;
			}
		    if(!isset($show)) {
				$show = '';
			}
		   	pncgroups_view_main($showgid, $min, $show);
           	break;
	}
}
?>
