<?php
// File: $Id: pncgroupsmembers.php,v 1.1.1.1 2004/05/06 03:58:12 dyksjare Exp $ $Name:  $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Franky Chestnut !
// Purpose of file: Block Members List of the pncGroups AddOn
// ----------------------------------------------------------------------

pnSecAddSchema('pncgroups:pncgroupsmembers:', 'Block title::');

$blocks_modules['pncgroupsmembers'] = array(	'module'			=> 'pncgroups',
												'text_type'			=> 'pncgroupsmembers',
												'text_type_long'	=> 'pncGroups Members block',
												'func_display' 		=> 'pncgroups_pncgroupsmembers_display',
												'func_edit'			=> 'pncgroups_pncgroupsmembers_modify',
												'func_update'		=> 'pncgroups_pncgroupsmembers_update',
												'allow_multiple'	=> true,
												'form_content'		=> false,
												'form_refresh'		=> false,
												'show_preview'		=> true);

function pncgroups_pncgroupsmembers_display($blockinfo)
{

	if (!pnSecAuthAction(0, 'pncgroups:pncgroupsmembers:', "$blockinfo[title]::", ACCESS_READ)) {
		return;
	}
		
	// Get variables from content block
	$vars = pnBlockVarsFromContent($blockinfo['content']);
	
    if (empty($vars['pncgselected'])) {
        $vars['pncgselected'] = "2";
    }

	if (empty($vars['showcore'])) {
	    $vars['showcore'] = "1";
	}
	
	if (empty($vars['selectlimit'])) {
	    $vars['selectlimit'] = "15";
	}

	if ($vars['showcore'] == "1") {
		$showme = "1";
	} else {
		$showme = "0";
	}
	
    // Database information
    pnModDBInfoLoad('pncgroups');
    list($dbconn) = pnDBGetConn();
    $pntable =pnDBGetTables();
	$pncgtable = $pntable['pncgroups'];
    $pncgcolumn = &$pntable['pncgroups_column'];
    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];
	$groupmship = $pntable['group_membership'];
	$groupmshipcolumn = &$pntable['group_membership_column'];

    $gcolumn = &$pntable['groups_column'];
	$gnameresult = $dbconn->Execute("	SELECT	$gcolumn[gid],
												$gcolumn[name]
										FROM	$pntable[groups]
										WHERE	$gcolumn[gid]='".pnVarPrepForStore($vars['pncgselected'])."'");
    if($dbconn->ErrorNo()<>0) {
	    echo "DB Error: " . $dbconn->ErrorMsg();
    }
		
	list($gid, $gname) = $gnameresult->fields;
	
	$coreresult = $dbconn->Execute("SELECT	$pncgcolumn[type]
									FROM	$pncgtable
									WHERE	$pncgcolumn[gid]='".pnVarPrepForStore($vars['pncgselected'])."'");
	list($type) = $coreresult->fields;
	
	if ($type == '-1' && $var['showcore'] == "0") {
		$showme = "0";
	}
	
	$ucolumn = &$pntable['group_membership_column'];

	$query = "	SELECT $ucolumn[uid]
				FROM $pntable[group_membership]
				WHERE $ucolumn[gid]='".pnVarPrepForStore($vars['pncgselected'])."'";

	$querycount = $dbconn->Execute("SELECT	count(*)
									FROM 	$pntable[group_membership]
									WHERE	$ucolumn[gid]='".pnVarPrepForStore($vars['pncgselected'])."'");
	list($howmuch) = $querycount->fields;
	
	$gmembresult = $dbconn->SelectLimit($query, pnVarPrepForStore($vars['selectlimit']));

    if($dbconn->ErrorNo()<>0) {
	    echo "DB Error: " . $dbconn->ErrorMsg();
    }
	
	$output = new pnHTML();
	$output->SetInputMode(_PNH_VERBATIMINPUT);
	
	if ($showme == "1") {
		$output->Text("<center><b>".pnVarPrepForDisplay($gname)." :</b></center><br>");
	
		while(list($uid) = $gmembresult->fields) {
			$gmembresult->MoveNext();
			$uinfo[$uid] = pnUserGetVars($uid);
			$gusername = $uinfo[$uid]['uname'];

			$output->Text("<img src=\"modules/pncgroups/images/member.gif\" border=\"0\" width=\"17\" height=\"14\">\n"); 
			$output->Text("<a href=\"user.php?op=userinfo&uname=".pnVarPrepForDisplay($gusername)."\">");
			$output->Text(pnVarPrepForDisplay($gusername));
			$output->Text("</a>");
			$output->Text(" <a href=\"modules.php?op=modload&name=Messages&file=replypmsg&send=1&uname=".pnVarPrepForDisplay($gusername)."\">");
			$output->Text("<img src=\"modules/pncgroups/images/mail.gif\" title=\"PM!\" border=\"0\"></a>");
			$output->Text("<br><br>");
		}

		if ($howmuch > $vars['selectlimit']) {
			$output->Text("<center>");
			$output->Text("<a href=\"modules.php?op=modload&name=pncgroups&file=index&showgid=".pnVarPrepForDisplay($gid)."\">");
			$output->Text(_SHOWMEMORE);
			$output->Text("</a>");
			$output->Text("</center>");
			$output->Text("<br><br>");
		}

		$output->Text("<center>");
		$output->Text("<a href=\"modules.php?op=modload&name=pncgroups&file=index\">");
		$output->Text(_SHOWMEALL);
		$output->Text("</a>");
		$output->Text("</center>");
	} else {
		$output->Text("<center><b>");
		$output->Text(_NOTHINGTOSHOW);
		$output->Text("</b></center><br>");
	}
	
	$output->SetInputMode(_PNH_PARSEINPUT);
    $blockinfo['content'] = $output->GetOutput();
    return themesideblock($blockinfo);

}

/**
 * modify block settings
 */
function pncgroups_pncgroupsmembers_modify($blockinfo)
{
    // Create output object
    $output = new pnHTML();

    // Get current content
    $vars = pnBlockVarsFromContent($blockinfo['content']);

    // Defaults
    if (empty($vars['pncgselected'])) {
        $vars['pncgselected'] = "2";
    }
	
	if (empty($vars['showcore'])) {
	    $vars['showcore'] = "1";
	}

	if (empty($vars['selectlimit'])) {
	    $vars['selectlimit'] = "15";
	}
	
    // Create row
    $row = array();
	
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
	
	$row[] = $output->Text(_SHOWMECORE);
	
	$showcore[] = array('id'	=> "0",
						'name'	=> _GNO);
	$showcore[] = array('id'	=> "1",
						'name'	=> _GYES);
	$row[] = $output->FormSelectMultiple(	'showcore',
	                                     	$showcore,
											0,
	                                        1,
	                                        $vars['showcore']);
	
	$output->SetOutputMode(_PNH_KEEPOUTPUT);
	$output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
	
	list($dbconn) = pnDBGetConn();
    $pntable =pnDBGetTables();
    $grouptable = $pntable['groups'];
    $groupcolumn = &$pntable['groups_column'];

    $gcolumn = &$pntable['groups_column'];
	$gnameresult = $dbconn->Execute("	SELECT $gcolumn[gid], $gcolumn[name]
										FROM $pntable[groups]");
    if($dbconn->ErrorNo()<>0) {
	    echo "DB Error: " . $dbconn->ErrorMsg();
    }

	while(list($gid, $gname) = $gnameresult->fields) {
		
		$gnameresult->MoveNext();
        $listgroup[] = array('id' => $gid,
                             'name' => $gname);		
	}
	
	$row = array();
	$output->SetOutputMode(_PNH_RETURNOUTPUT);
	$row[] = $output->Text(_SHOWMEWHAT);
    $row[] = $output->FormSelectMultiple('pncgselected',
                                         $listgroup,
										 0,
                                         1,
                                         $vars['pncgselected']);
	$output->SetOutputMode(_PNH_KEEPOUTPUT);

    // Add row
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(_SELECTLIMIT);
    $row[] = $output->FormText('selectlimit',
                               pnVarPrepForDisplay($vars['selectlimit']),
                               5,
                               5);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    // Add row
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Return output
    return $output->GetOutput();
}

/**
 * update block settings
 */
function pncgroups_pncgroupsmembers_update($blockinfo)
{
    list(	$vars['pncgselected'],
			$vars['showcore'],
			$vars['selectlimit']) = pnVarCleanFromInput(	'pncgselected',
															'showcore',
															'selectlimit');

    $blockinfo['content'] = pnBlockVarsToContent($vars);

    return $blockinfo;
}
?>