<?php
// File: $Id: pub-adddownload.php,v 1.1.1.1 2004/05/06 03:58:38 dyksjare Exp $ $Name:  $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Francisco Burzi
// Purpose of file:
// ----------------------------------------------------------------------


/**
 * User Interface to Upload a publication to the server
 * 
 * @author Jared Dykstra
 * 
 */
function AddDownload() {
    include("header.php");

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    if (!(pnSecAuthAction(0, 'publications::Item', '::', ACCESS_COMMENT))) {
        echo _DOWNLOADSADDNOAUTH;
        include 'footer.php';
        return;
    }
    $maindownload = 1;
    menu(1);

    OpenTable();
    echo "<center><font class=\"pn-title\">"._ADDADOWNLOAD."</font></center><br><br>";
    if (pnUserLoggedIn() || pnConfigGetVar('downloads_anonadddownloadlock') != 1) {
        echo "<font class=\"pn-titlel\">"._INSTRUCTIONS.":</font><br>"
        ."<font class=\"pn-normal\"><strong><big>&middot;</big></strong> "._DSUBMITONCE."<br>"
        ."<strong><big>&middot;</big></strong> "._DPOSTPENDING."<br>"
        ."<strong><big>&middot;</big></strong> "._USERANDIP."</font><br>"
        ."<p>&nbsp;</p><table border=0 align=center width=95%><tr><td>"
        ."<form action=\"modules.php\" enctype=\"multipart/form-data\" method=\"post\">"
        ."<input type=\"hidden\" name=\"op\" value=\"modload\">\n"
        ."<input type=\"hidden\" name=\"name\" value=\"".$GLOBALS['ModName']."\">\n"
        ."<input type=\"hidden\" name=\"file\" value=\"index\">"
        ."<font class=\"pn-normal\">"._DOWNLOADNAME."</font>: </td><td><input type=\"text\" name=\"title\" size=\"50\" maxlength=\"100\">"
            ."</td></tr><tr><td>"
        ."<font class=\"pn-normal\">"._FILEURL."</font>: </td><td><input type=\"file\" name=\"pubfile\" size=\"34\" maxlength=\"250\">"
            ."</td></tr><tr><td>";
        $column = &$pntable['publications_categories_column'];
        $result=$dbconn->Execute("SELECT $column[cid], $column[title]
                                FROM $pntable[publications_categories]
                                ORDER BY $column[title]");
        echo "<font class=\"pn-normal\">"._CATEGORY."</font>: </td><td><select name=\"cat\">";
        while(list($cid, $title) = $result->fields) {

            $result->MoveNext();
            if (pnSecAuthAction(0, 'publications::Category', "$title::$cid", ACCESS_COMMENT)) {
                echo "<option value=\"$cid\">".pnVarPrepForDisplay($title)."</option>";
                $column=&$pntable['publications_subcategories_column'];
                $result2=$dbconn->Execute("SELECT $column[sid], $column[title]
                                           FROM $pntable[publications_subcategories]
                                           WHERE $column[cid]='".pnVarPrepForStore($cid)."' ORDER BY $column[title]");
                while(list($sid, $stitle) = $result2->fields) {

                    $result2->MoveNext();
                    if (pnSecAuthAction(0, 'publications::Category', "$stitle::$sid", ACCESS_COMMENT)) {
                        echo "<option value=\"$cid-$sid\">".pnVarPrepForDisplay($title)." / ".pnVarPrepForDisplay($stitle)."</option>";
                    }
                }
            }
        }
        echo "</select>"
            ."</td></tr><tr><td colspan=2>"
            ."<br /><font class=\"pn-normal\">"._LDESCRIPTION."</font><br /><textarea name=\"description\" cols=\"80\" rows=\"10\"></textarea>"
            ."</td></tr><tr><td>"
            ."<font class=\"pn-normal\">"._AUTHORNAME."</font>: </td><td><input type=\"text\" name=\"nname\" size=\"30\" maxlength=\"60\">"
            ."</td></tr><tr><td>"
            ."<font class=\"pn-normal\">"._AUTHOREMAIL."</font>: </td><td><input type=\"text\" name=\"email\" size=\"30\" maxlength=\"60\">"
            ."</td></tr><tr><td colspan=2>"
            ."<p>&nbsp;</p><p align=center>"
            ."<input type=\"hidden\" name=\"req\"      value=\"Add\">"
            ."<input type=\"hidden\" name=\"homepage\" value=\"/\">"
            ."<input type=\"hidden\" name=\"filesize\" value=\"0\">"
            ."<input type=\"hidden\" name=\"version\"  value=\"1.0\">"
            ."<input type=\"submit\" value=\""._ADDTHISFILE."\"><br /><font class=\"pn-normal\">"._GOBACK."</font><br><br>"
            ."</p></form></tr></td></table>";
    } else {
        echo "<center><font class=\"pn-normal\">"._DOWNLOADSNOTUSER1."<br>"
        .""._DOWNLOADSNOTUSER2."<br><br>"
        .""._DOWNLOADSNOTUSER3."<br>"
        .""._DOWNLOADSNOTUSER4."<br>"
        .""._DOWNLOADSNOTUSER5."<br>"
        .""._DOWNLOADSNOTUSER6."<br>"
        .""._DOWNLOADSNOTUSER7."<br><br>"
        .""._DOWNLOADSNOTUSER8."</font></center>";
    }
    CloseTable();
    include("footer.php");
}

/**
 * Upload a local file to a directory on the server and set default fields
 * 
 * @author Jared Dykstra
 */
function Add()
{
    list($title,
         $nname,
         $cat,
         $description,
         $name,
         $email,
         $filesize,
         $version,
         $homepage) = pnVarCleanFromInput('title',
                                          'nname',
                                          'cat',
                                          'description',
                                          'name',
                                          'email',
                                          'filesize',
                                          'version',
                                          'homepage');
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $column=&$pntable['publications_downloads_column'];

// Check if No Categories Defined
    if (!isset($cat)) {
        AddError(_DOWNLOADSNOCATS, $destFile);
        return;
    }

// Check if access is not restricted
    $catname = downloads_CatNameFromCID($cat);
    if (!(pnSecAuthAction(0, 'publications::Item', "$title:$catname:", ACCESS_COMMENT))) {
        AddError(_DOWNLOADSNOAUTH, $destFile);
        return;
    }

// Check If the Download Already Exists
    $result = $dbconn->Execute("SELECT count(*)
                              FROM $pntable[publications_downloads]
                              WHERE $column[url]='".pnVarPrepForStore($url)."'");
    list($numrows) = $result->fields;
    if ($numrows>0) {
        AddError(_DOWNLOADALREADYEXT);
        return;
    }

// Check if Title exist
    if ($title=="") {
        AddError(_DOWNLOADNOTITLE);
        return;
    }

// Check if Description exist
    if ($description=="") {
        AddError(_DOWNLOADNODESC);
        return;
    }


    ///////////////

    // Upload the file and setup vars
    switch($_FILES['pubfile']['error']) {
    case 0:
        // Good... Do Nothing
        break;
    case 1:
    case 2:
        AddError(_ERR_MAX_SIZE);
        return;
    case 3:
        AddError(_ERR_INCOMPLETE);
        return;
    case 4:
        AddError(_ERR_NO_UPLOAD);
        return;
    default:
        AddError(_ERR_UP_UNSPECIFIED);
        return;
    }

    // Get Configuration Variables
    include("modules/$name/config.php");
    $destDir = _UPLOAD_DIRECTORY_INT;
    $uploadURL = _UPLOAD_DIRECTORY_SVR;

    // Set the File Size
    $filesize = $_FILES['pubfile']['size'];
    // Set $url to the URL of the uploaded file
    $url = $uploadURL . $_FILES['pubfile']['name'];
    // TODO: Set homepage to the base site URL
    $homepage = "/";

    // Make sure no files on the server will be overwritten
    $destFile = $destDir . $_FILES['pubfile']['name'];
    if (!file_exists($destFile)) {        
        if (! move_uploaded_file($_FILES['pubfile']['tmp_name'], $destFile)) {
            AddError(_ERR_CONFIG);
            return;
        }
    } else {
        AddError($url."<br>"._ERR_EXIST);
        return;
    }


    // All error checking done & File Has been Uploaded
    include 'header.php';
    menu(1);
    OpenTable();

    if (pnUserLoggedIn()) {
        $submitter = pnUserGetVar('uname');
    }
    

        $cat = explode("-", $cat);
        if	(!isset($cat[0]) || !is_numeric($cat[0])){
            $cat[0] = 0;
        }
        if	(empty($cat[1]) || !is_numeric($cat[1])){
            $cat[1] = 0;
        }

        $column = &$pntable['publications_newdownload_column'];
	$newtable = $pntable['publications_newdownload'];
	$lid = $dbconn->GenID($newtable);
        $result=$dbconn->Execute("INSERT INTO $newtable
                                ($column[lid], $column[cid], $column[sid],
                                 $column[title], $column[url], $column[description],
                                 $column[name], $column[email], $column[submitter],
                                 $column[filesize], $column[version],
                                 $column[homepage])
                                VALUES (".(int)pnVarPrepForStore($lid).", ".(int)$cat[0].", ".(int)$cat[1].", '".pnVarPrepForStore($title)."', '".pnVarPrepForStore($url)."',
                                 '".pnVarPrepForStore($description)."', '".pnVarPrepForStore($nname)."', '".pnVarPrepForStore($email)."', '".pnVarPrepForStore($submitter)."',
                                 '".pnVarPrepForStore($filesize)."', '".pnVarPrepForStore($version)."', '".pnVarPrepForStore($homepage)."')");
//        //OpenTable();
        echo "<center><font class=\"pn-normal\">"._DOWNLOADRECEIVED."</font><br>";
        if ($email == "") {
            echo "<font class=\"pn-normal\">"._CHECKFORIT."</font>";
        }
//        //CloseTable();

    CloseTable();
    include 'footer.php';

}


/**
 * Error condition encountered in the File Upload Process
 * This function returns things to a stable state
 * 
 * @author Jared Dykstra
 * 
 * @param msg   - Error Message
 */
function AddError($msg) {
    include 'header.php';
    menu(1);
    OpenTable();
    echo "<center><font class=\"pn-normal\">".$msg."</font><br><br>"
        ."<font class=\"pn-normal\">"._GOBACK."</font>";
    CloseTable();
    include("footer.php");
}

?>
